
//          Copyright Igor Nikiforov 1995 - 2009.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#include <pro_ext.h>
#include <string.h>
#include <locale.h>
#include <math.h>  

#pragma warning(disable : 4996) //  warning C4996: '_strupr' was declared deprecated


// -------------------------------------------------------------------------------
#define  DOS  0  // version FoxPro 2.6 for DOS
#define  WDS  1  // version FoxPro 2.6 for Windows
#define  VFP  2  // version Visual FoxPro

#define  VERSION VFP  //     FoxPro 2.6 DOS   DOS,  FoxPro 2.6 Windows    WDS
// -------------------------------------------------------------------------------


#define  VFP9ANDABOVE  1    // version for VFP 9.0 

#define  ENGLISHLANGUAGE  0  //  1     ,   


#if  VERSION == VFP
#define  _RetNULL(VERSION) \
	{	 Value aVal; \
	aVal.ev_type = '0'; \
	aVal.ev_long = (long)'L'; \
	_RetVal(&aVal) ; \
	}
#else  // version for FoxPro 2.6 DOS or Windows
#if  VERSION == DOS
#include <dos.h>
#endif
#include <direct.h>
#include <stdlib.h>
#define _ltoa   ltoa 
#define _strlwr _fstrlwr 
#define _strupr _fstrupr 
typedef unsigned short USHORT;
#define  _RetNULL(VERSION) \
_RetLogical(0)  ;  // Nothing
#undef  VFP9ANDABOVE  
#define VFP9ANDABOVE  0
#endif


#if ENGLISHLANGUAGE
#define  LOCLANGUAGE "eng"
#if VERSION == VFP
#if VFP9ANDABOVE
#define  VERSIONST_DENIS "2.1 this is English version for VFP 9.0 \n 2009-11-22 by Igor Nikiforov\n udfunctions@gmail.com"
#else 
#define  VERSIONST_DENIS "2.1 this is English version for VFP 8.0 and below\n 2009-11-22 by Igor Nikiforov\n udfunctions@gmail.com"
#endif
#else 
#if VERSION == DOS
#define  VERSIONST_DENIS "2.1 this is English version for FoxPro 2.6 DOS\n 2009-11-22 by Igor Nikiforov\n udfunctions@gmail.com"
#else 
#define  VERSIONST_DENIS "2.1 this is English version for FoxPro 2.6 Windows\n 2009-11-22 by Igor Nikiforov udfunctions@gmail.com"
#endif
#endif
#else 
#define  LOCLANGUAGE "rus"
#if VERSION == VFP
#if VFP9ANDABOVE
#define  VERSIONST_DENIS "2.1     VFP 9.0  \n 2009-11-22   \n udfunctions@gmail.com" 
#else 
#define  VERSIONST_DENIS "2.1     VFP 8.0  \n 2009-11-22   \n udfunctions@gmail.com"
#endif
#else 
#if VERSION == DOS
#define  VERSIONST_DENIS "2.1     FoxPro 2.6 DOS\n 2009-11-22   \n udfunctions@gmail.com"
#else 
#define  VERSIONST_DENIS "2.1     FoxPro 2.6 Windows\n 2009-11-22   \n udfunctions@gmail.com"
#endif
#endif
#endif


#define  NONE  0
#define  MAIN  1
#define  DEBUGLEVEL  NONE

#define  DEBUGMSG(level, msg) \
	if  (DEBUGLEVEL & level)   \
_Dialog (4,(msg),"Continue",(char FAR *)0, (char FAR *)0, 1, 1);

#define  SHOWMSG(level, msg) \
	if  (DEBUGLEVEL & level)   \
_PutStr(msg) ;


//--------------------------------------------------------------------------
#define   DFTBREAK	 " \t\n\r"     /*    default break string	  */
#define   MAXBREAK	  256	       /*    maximum break string length  */
#define   SPACE32 (unsigned char)32
//--------------------------------------------------------------------------


//       (  wordtran)
#if VERSION == VFP
#define  MAXCNTWORDS  110000   
#else 
#if VERSION == DOS
#define  MAXCNTWORDS 2000 
#else 
#define  MAXCNTWORDS 2500  
#endif
#endif


#if  VERSION == VFP 
#if ENGLISHLANGUAGE
#define  ERRMSGMAXCNTWORDS "The first parameter contains more than 110000 strings or words!"
#else 
#define  ERRMSGMAXCNTWORDS "    110000     !"
#endif
#endif

#if VFP9ANDABOVE
#define  MAXARRSIZE  65000  //        GETALLWORDS,       
#if ENGLISHLANGUAGE
#define  ERRMSGMAXARRSIZE  "The second parameter contains more than 65000 words!"
#else 
#define  ERRMSGMAXARRSIZE  "    65000 !"
#endif
#else 
#if  VERSION == VFP 
#define  MAXARRSIZE  16250   //        GETALLWORDS
#if ENGLISHLANGUAGE
#define  ERRMSGMAXARRSIZE  "The second parameter contains more than 16250 words!"
#else 
#define  ERRMSGMAXARRSIZE  "    16250 !"
#endif
#else 
#if VERSION == DOS
#define  MAXARRSIZE  2820   //        GETALLWORDS   DOS
#if ENGLISHLANGUAGE
#define  ERRMSGMAXARRSIZE  "The second parameter contains more than 2820 words!"
#define  ERRMSGMAXCNTWORDS "The first parameter contains more than 2000 strings or words!"
#else 
#define  ERRMSGMAXARRSIZE  "    2820 !"
#define  ERRMSGMAXCNTWORDS "    2000    !"
#endif
#else 
#define  MAXARRSIZE  4000 //        GETALLWORDS   Windows
#if ENGLISHLANGUAGE
#define  ERRMSGMAXARRSIZE  "The second parameter contains more than 4000 words!"
#define  ERRMSGMAXCNTWORDS "The first parameter contains more than 2500 strings or words!"
#else 
#define  ERRMSGMAXARRSIZE  "    4000 !"
#define  ERRMSGMAXCNTWORDS "    2500    !"
#endif
#endif
#endif
#endif



#if DEBUGLEVEL
void FAR  PutNumLong( long i) {
	Value  HoldVal ;
	_MemFill(&HoldVal,0, sizeof(Value)) ;
	HoldVal.ev_type = 'I' ;
	HoldVal.ev_width = 10   ;
	HoldVal.ev_long= i ;
	_PutValue(&HoldVal) ;
}
#endif


#if  VERSION == VFP 
int ( __cdecl *memcompar ) (const void *s1, const void *s2, size_t n);
#else
int (*memcompar )( const void FAR *s1, const void FAR *s2, size_t n );
#define memcmp  _fmemcmp 
#define memicmp _fmemicmp
#endif

int ( __cdecl *compar ) ( Value FAR * pkey, Locator FAR * pbase) ;
int __cdecl comparCHAR ( Value FAR * pkey, Locator FAR *  pbase) ;
int __cdecl comparCHAREXACT ( Value FAR * pkey, Locator FAR * pbase) ;
int __cdecl comparN ( Value FAR * pkey, Locator FAR * pbase) ;
int __cdecl comparD ( Value FAR * pkey, Locator FAR * pbase) ;
int __cdecl comparL ( Value FAR * pkey, Locator FAR * pbase) ;

#if  VERSION == VFP 
int __cdecl comparY ( Value FAR * pkey, Locator FAR * pbase) ;
#endif
/**************************************************************
Create a ASCIIZ sting from Value passed parameter
***************************************************************/
void FAR  NullTerminate(Value FAR *cVal)  {
	if (!_SetHandSize(cVal->ev_handle, cVal->ev_length + 1))
		_Error(182); // "Insufficient memory"
	_HLock(cVal->ev_handle);
	((char FAR *) _HandToPtr(cVal->ev_handle))[cVal->ev_length] = '\0';
	_HUnLock(cVal->ev_handle);
}

void FAR  FillVal(ParamBlk FAR *parm, Value FAR * HoldVal, int ParmNum) {
	if (parm->p[ParmNum].loc.l_type == 'R') // pass by reference
		_Load(&parm->p[ParmNum].loc, HoldVal) ;
	else
		_MemMove(HoldVal, &parm->p[ParmNum].val, sizeof(Value)) ;
}


MHANDLE gethandle(ParamBlk FAR *parm, int pnum)
//--------------------------------------------------------------------------
// Returns an MHANDLE to a copy of the string passed in parameter pnum of
// parm.  This function null-terminates the handle also.  It is useful
// for functions that expect to see character data, but don't know whether
// the data will be passed by value or reference, or through a memo field.
// Author:  Walter J. Kennamer History: Initially written November 25, 1991
// changed by Igor Nikiforov, the 3-th parameter has been added for memory optimization
//--------------------------------------------------------------------------
{
	Value FAR *v, FAR *memvarvalue;
	Value valbuffer;
	Locator FAR *varlocate;
	int errcode	 = 0;
	// Various types for managing memo fields
	int memchan;       // memo file channel
	long int memsize, memread, memseek, memfind;
	MHANDLE memohand = 0;
	
	v = &parm->p[pnum].val;
	if (v->ev_type == 'C') {
		// Check to see if we can allocate the memory needed
        // the new version changed by Igor Nikiforov
		// now we must not free handles passed to them in their ParamBlk !
		_HUnLock(v->ev_handle);
		if (!_SetHandSize(v->ev_handle, v->ev_length+1)) {
			_Error(182); // "Insufficient memory" "There is not enough memory to complete this operation."
		}
		_HLock(v->ev_handle);
		*((char FAR *)_HandToPtr(v->ev_handle) + v->ev_length) = '\0';
		_HUnLock(v->ev_handle);
		return v->ev_handle;
	}
	else if (v->ev_type == 'R') {  // This parameter was passed by reference.  See what kind it is.
		varlocate  = &parm->p[pnum].loc;
		if ( varlocate->l_where > 0 ) {
			memchan = _MemoChan(varlocate->l_where);  // since it has a file channel, it's a memo field
			
			if ((memfind = _FindMemo(varlocate)) < 0)  // find the memo file offset
				_Error(-(int)memfind);
			
			memsize = _MemoSize(varlocate);	// find the memo size
			if (memsize < 0)
				_UserError("Invalid memo size\n");
#if VERSION != VFP
			if (memsize > 0x7FFFL)
				_UserError("Memo is too large -- 32K limit");
#endif
			memseek = _FSeek(memchan,memfind,0);	         // move the file pointer
			
			memohand  = _AllocHand((unsigned int)memsize+1);  // Allocate enough memory to read in the memo field
			if (memohand == 0)
				_Error(182);	// insufficient memory
			memread = _FRead(memchan,_HandToPtr(memohand),(int)memsize);  // Read the memo into our handle
			if (memread != memsize)
				_UserError("Error reading memo field\n");
			
			*((char FAR *)_HandToPtr(memohand) + memsize) = '\0';  // Make sure the handle is null-terminated
			return memohand;
		}
		else {
			// This is some other kind of memory variable passed by reference.
			// It is not a memo field.  Store it into a value structure so that we can learn its secrets.
			memvarvalue = &valbuffer;
			if ( (errcode = _Load(varlocate,memvarvalue)) != 0)
				_Error(-errcode);
			
			if (memvarvalue->ev_type == 'C') { 	   // This is a character string.
				NullTerminate(memvarvalue) ; 
				return memvarvalue->ev_handle;
			}
			else {
				_FreeHand(memvarvalue->ev_handle); // Something passed by reference other than char or memo
				return 0;
			}
		}
	}
	else {
		return 0;  // Something passed by value other than char
	}
}

//--------------------------------------------------------------------------
int k_at(char FAR *strg, char chr)
// This procedure is for internal use within FPATH.  It returns
// the byte number (starting with 1) of the first occurrence of chr
// in strg, or 0 if chr is not found in strg.
// Author:  Walter J. Kennamer History: Initially written May 10, 1991
//--------------------------------------------------------------------------
{
	char FAR *p;
	p = strchr(strg,chr);
	if (p != NULL)
		return(p-strg+1);
	else
		return(0);
}
//--------------------------------------------------------------------------
char FAR *k_alltrim(char FAR *p, char FAR *outstr)
// This procedure is for internal use within FPATH.  It trims leading
// and trailing white space from the string pointed to by p.
// Author:  Walter J. Kennamer History: Initially written May 10, 1991
//--------------------------------------------------------------------------
{
	char FAR *lead, FAR *trail;
	*outstr = 0;
	
	for (lead = p ; *lead && isspace(*lead); lead++)  // count leading spaces
		;
	if (*lead) {   // it isn't all white space or empty
		// count trailing spaces
		for (trail = p+_StrLen(p)-1 ; trail > p && isspace(*trail); trail--)
			;
		_MemMove(outstr,lead,(unsigned int)(trail - lead) + 1);
		*(outstr + (unsigned int) (trail - lead) + 1 ) = 0;
	}
	return(outstr);
}

/*   mybsearch    
   ,       -   
(     bsearch,     ,    - )  */
long mybsearch(Value FAR * key,		/* Key to be located */
			   Locator FAR * pbase,
			   long nel,		/* Number of elements in the table */
			   int ( __cdecl *compar)(Value FAR *, Locator FAR * )) /* Comparison function */ 
{
	long begin, base, last;
	int res ;
	
	if (nel == 0)
		return 0L;
	
	base = begin =  pbase->l_sub1 ;    /* Beginning of table */
	last = base +  (nel - 1);
	
	while (last >= base) {
		pbase->l_sub1 =  (USHORT)((last + base)/2);
		res = ( *compar)(key, pbase);
		if (res == 0) { /* Key found */
			do {   //            
				--(pbase->l_sub1) ;
				if (pbase->l_sub1<begin)
					break; 
			} while ((*compar)(key, pbase) == 0) ;
			return (++pbase->l_sub1);	
		}
		if (res < 0)
			last =  pbase->l_sub1 - 1;
		else
			base =  pbase->l_sub1 + 1;
	}
	return 0L;		/* Key not found */
}

// --------------------- Begin dansliste, checkliste, whendansliste --------------------------------
void FAR dansliste(ParamBlk FAR *parm) {
	char   FAR  *string;
	char   flags = 0 ;
	int    i, j=0 , beg = 0, result=0, length  ;
	long   Number_param=0, chislo=0 ;
	
	Number_param = parm->p[0].val.ev_long;  /* Number_param - ,       */  
	
	if ( Number_param < 0 || Number_param > 2147483647 )
		_UserError("The first parameter must be between 0 and 2,147,483,647");
	
	string = _HandToPtr(parm->p[1].val.ev_handle);  /* string -   ,       */  
	length = parm->p[1].val.ev_length ;  	/* length -    ,       */  
	
											/*               
											 -    
											     ,       
											            
											1)    
											a)        , 
											     ,         ,     1) 
											       ,     2) 
											   b)          
											      ,      1) 
											   c)          
											         ,     1)
											   2)    
											   a)      ,    ,     1) 
											   b)             1),     -        
											   3)     2.147.483.647,     
											   0x1,  0x2, 0x4, 0x8,0x10,0x20,0x40,0x80
											   0xFE,0xFD,0xFB,0xF7,0xEF,0xDF,0xBF,0x7F
											     ( 0x1,0xFE)  (    )
											        
											      ,      
											       
											     ( 0x2,0xFD) (    )
												         ,   
												    ,   
												    ( 0x4,0xFB)  (       ) 
												     (0x20,0xDF)  (      ) 
	    	*/
	
	
	for (i = length-1 ; i>=0  ; i--) {
		if ( (string[i] >= '0') && (string[i] <= '9') )
			break;  
	}
	length =  i + 1;
	
	for ( i=0 ; i <= length-1 ; i++) {
		if ( (string[i] >= '0') && (string[i] <= '9') )
			break;  
	}
	beg =  i;
	
	flags |= 0x4 ;  /*       */
	
	for (i = length-1 ; (i>=beg) && (result==0) ; i--) {
		switch (  string[i] ) {
		case ',' :
		/*      (    )
			        ,       */ 
			if ( !(flags & 0x1) ) {
				flags |= 0x1  ;         /*     (    )   */
				flags &= 0xFD ; 		   /*       (   )               */
				if ( flags & 0x20 ) {   /*               */
					flags |= 0x4  ;     /*        */
					flags &= 0xDF  ;    /*            */
				}
				else {  /*               */
					if ( flags & 0x4 ) {  /*          */
						if ( chislo == Number_param  && j > 0) 
							result=1 ;
					}
					else {               /*    (     )  */
						flags |= 0x4  ;  /*        */
						if ( chislo <= Number_param && chislo>=0 ) //    2147483647    long  
							result=1 ;
					}
					chislo=0 ;
					j = 0    ;
				}
			}
			break ;
		case '-' : 
		/*           , 
			     ,         */
			if ( !(flags & 0x20) ) {
			/*     (    )  
				      (   )   */
				if ( !(flags & 0x1) && !(flags & 0x2) ) {
					flags |= 0x1  ; /*     (    )   */
					flags |= 0x2  ; /*     (   )               */
					if ( chislo >= Number_param ) {
					/*           ,    ,      
						  ,         */
						flags &= 0xDF  ;
						flags &= 0xFB  ;
					}
					/*          ,  
					            */
					else  {
						flags |= 0x4   ;
						flags |= 0x20  ;
					}
					chislo=0 ;
					j = 0 ;
				}
			}
			break ; 
			
		default: 
			if ( (string[i] >= '0') && (string[i] <= '9') && (j<10) ) {
				flags &= 0xFE ;  /*     (     ) */
				if ( !(flags & 0x20) ) {
					chislo += (string[i]-'0')* (long)pow(10,j++);  /*              */
				}
			}
		}      
	}  
	
	/*   -	 result .F.   chislo    
	           */
	if ( (result==0) && (chislo !=0) && !(flags & 0x20)) {
		if ( flags & 0x4 ) {  /*          */
			if ( chislo == Number_param ) 
				result=1 ;
		}
		else {  /*    (     ) */
			if ( chislo <= Number_param  && chislo>=0 ) //    2147483647    long  
				result=1 ;   //           ,    ,   .T.  
		}
		
	}
	_RetLogical(result)  ;  /*    FoxPro  result = 0,   .F.,	  result = 1,  .T. */
}       

#define  NL22      22

#if  ENGLISHLANGUAGE
#define CHAINE1 "WAIT WIND TIME 3 [       character is wrong ! ] "
#define CHAINE2 "WAIT WIND TIME 3 [ You have entered a value that exceeds 2,147,483,647!] "
#define CHAINE3 "WAIT WIND NOWA [Enter a list of integers and/or ranges of integers to check separated by commas, for example: \"1,3,5-8,14,15,27-36,45\", etc.]" 
#else
#define CHAINE1 "WAIT WIND TIME 3 [          ! ] "
#define CHAINE2 "WAIT WIND TIME 3 [    2147483647 ! ] "
#define CHAINE3 "WAIT WIND NOWA [  \"1,3,5-8,14,15,27-36,45\"  ..( -  )]" 
#endif


void FAR checkliste(ParamBlk FAR *parm) {  /*      VALID (   dansliste) */
	char   FAR  *string;
	char   flags = 0 ;
	const  char   dix = 10 ;
	int    i, j=0 , result=1, length  ;
	long   chislo=0,multipl=1 ;
	char   home[]="KEYB \"{HOME}\"" ;
	char   keyb[]="KEYB \"{RIGHTARROW}\"" ;
	char   fsimvol[]= CHAINE1 ;
	
	string = _HandToPtr(parm->p[0].val.ev_handle); /* string -   ,       */  
	length = parm->p[0].val.ev_length ; /* length -    ,       */  
	
	for ( i=0 ; i <= length-1 ; i++) {
		if ( (string[i] >= '0') && (string[i] <= '9') )
			break;  
		if ( string[i] != (char)32 ) {
			result = 0 ;
			multipl = i ;
			break;  
		}
	}
	
	if (result) {
		for (i = length-1 ; i>=0  ; i--) {
			if ( (string[i] >= '0') && (string[i] <= '9') )
				break;  
			if ( string[i] != (char)32 ) {
				result = 0 ;
				multipl = i ;
				break;  
			}
		}
	}
	
	/*               
	a)      ,         
	b)             ,   
	c)           ,   
	     -  
	  (0x1,0xFE) (    )
	          
	    
	  ( 0x2,0xFD) (    )
	       	     
	    	*/
	for (i = length-1 ; (i>=0) && (result!=0) ; i--)	{
		switch ( string[i] )  {
		case ' ' :  	/*      */
			break ;
		case ',' :
			/*      (    )             .F.  */ 
			if ( !(flags & 0x1) ) {
				flags |= 0x1  ;   /*     (    )   */
				flags &= 0xFD ;   /*       (   )               */
				chislo=0 ;
				j = 0    ;
			}
			else  {  /*     (    )     */
				multipl = i + 1 ;
				result=0  ;
			}
			break ;
			
		case '-' : 
			/*     (    ),       (   )   */
			if ( !(flags & 0x1) && !(flags & 0x2) ) {
				flags |= 0x1  ;  /*     (    )   */ 
				flags |= 0x2  ;   /*     (   )               */
				chislo=0 ;
				j = 0 ;
			}
			else {
				multipl = i  ;
				result=0  ;
			}
			break ; 
			
		default: 
			if ( (string[i] >= '0') && (string[i] <= '9')  ) {
				flags &= 0xFE ; 		   /*      (     ) */
				multipl=(j>0)?(multipl*dix):1 ;
				chislo=chislo+(string[i]-'0')*multipl ;
				j++;
				if (chislo<0) {   /*    2.147.483.647,   long    0,     */
					multipl = i - 1 ;
					result=0 ;
				}
			}
			else {
				multipl = i  ;
				result=0 ;
			}
			
		}      
	}
	if ( result==0 ) {
		if (chislo>=0) {
			chislo= multipl+1 ;
			if (chislo>100) {
				fsimvol[NL22-2]= (char)(chislo/100)+'0' ;
				chislo%=100 ;
			} 
			if (chislo>10) {
				fsimvol[NL22-1]= (char)(chislo/10)+'0' ;
				chislo%=10 ;
			} 
			fsimvol[NL22]= (char)(chislo)+'0' ;
			_Execute(fsimvol) ;
		}
		else {
			_Execute(CHAINE2);
		}
		_Execute(home) ;
		for ( j = 0 ; j<multipl  ; j++)  {
			_Execute(keyb) ;
		}    
		_RetInt(result,10)   ;
	}
	else 
		_RetLogical(result)   ; 
	
}       

void FAR whendansliste(ParamBlk FAR *parm) { /*       WHEN  (   dansliste) */
	_Execute(CHAINE3)  ;
	_RetLogical(1)  ; 
}

// --------------------- End dansliste, checkliste, whendansliste --------------------------------

#if !VFP9ANDABOVE
//  ICASE.C     Copyright: I.V. Nikiforov, 1999                                
//  This program represents function ICASE () -"Immediate CASE",
//  which similarly functions IIF (), simulating structure IF... ENDIF, simulates structure DO CASE... ENDCASE 
//       ICASE() - "  CASE" ,
//     IIF() ,   IF ...ENDIF,    DO CASE ... ENDCASE 
void FAR icase(ParamBlk FAR *parm)  {
	int i ;
	
	for (i = 0 ;i<parm->pCount-(parm->pCount%2); i+=2) {
		if (parm->p[i].val.ev_type=='L') {
			if (parm->p[i].val.ev_length) {
				_RetVal(&parm->p[i+1].val) ;
				return;
			}
		}
	}
	if ((parm->pCount%2) == 1)   // return the "otherwise" argument if found
		_RetVal(&parm->p[parm->pCount-1].val) ;
	else
		_RetNULL(VERSION)  // or .NULL. for VFP
		return;
}
#endif

void FAR UpperToLower(Value FAR * paVal) {
	NullTerminate(paVal) ; //  _strlwr   ,      
	_HLock(paVal->ev_handle);   // Lock string passed value
	_strlwr((char FAR *)_HandToPtr(paVal->ev_handle)) ;  //    
	_HUnLock(paVal->ev_handle); 
}

void FAR LowerToUpper(Value FAR * paVal) {
	NullTerminate(paVal) ; //  _strlwr   ,      
	_HLock(paVal->ev_handle);   // Lock string passed value
	_strupr((char FAR *)_HandToPtr(paVal->ev_handle)) ;  //    
	_HUnLock(paVal->ev_handle); 
}

void FAR  initcompar(Locator FAR * pbase, Value * paVal, char TYPE) {
	int errcode ;
	if (errcode = _Load(pbase, paVal))  //  pLocator->l_sub1     
		_Error(-errcode) ; // exits api
	
	if (TYPE)  //    0
		if (paVal->ev_type != TYPE)
			_Error(302) ; //   
}   

#if  VERSION == VFP 
int comparYY (CCY pkey, CCY bkey) {
	int r = 0 ;
	if  (pkey.HighPart > bkey.HighPart)
		r = 1 ;  
	else 
		if  (pkey.HighPart < bkey.HighPart)
			r = -1 ;  
		else
			if  (pkey.HighPart == bkey.HighPart) {				
				if  (pkey.LowPart > bkey.LowPart)
					r = 1 ;  
				else
					if  (pkey.LowPart < bkey.LowPart)
						r = -1 ;  
			} 
			return r ;  
}

int comparNY (double pkey, CCY bkey) {
	double r = (double)(bkey.HighPart * pow(2,32)/10000.0) + fabs((double)bkey.LowPart/10000.0);
	if  ( pkey > r )
		return 1 ;   
	else
		return ((pkey < r )?-1:0) ; 
}
#endif

int __cdecl comparCHAR ( Value FAR * pkey, Locator FAR * pbase) {
	int r ; 
	Value  aVal ;
	initcompar(pbase,&aVal,'C') ;
	
	//             1
	if (pbase->l_offset == 1)  //     ascanquick,       (  )
		LowerToUpper(&aVal) ;  //      
	
	
	_HLock(pkey->ev_handle) ;
	_HLock(aVal.ev_handle) ;
	
	//    ,        SET EXACT
	//   SET EXACT,  Comparison,        
	// pkey->ev_length == 0
	if (pkey->ev_length<aVal.ev_length) {
		r=_MemCmp(_HandToPtr(pkey->ev_handle),_HandToPtr(aVal.ev_handle),pkey->ev_length ) ;
	}   
	else {
		if (pkey->ev_length>aVal.ev_length) {
			r=_MemCmp(_HandToPtr(pkey->ev_handle),_HandToPtr(aVal.ev_handle),aVal.ev_length ) ;
			if (r==0)
				r=1 ;
		}   
		else {
			r=_MemCmp(_HandToPtr(pkey->ev_handle),_HandToPtr(aVal.ev_handle),pkey->ev_length ) ;   
		}  
	}  
	
	_HUnLock(pkey->ev_handle) ;
	_HUnLock(aVal.ev_handle) ;
	_FreeHand(aVal.ev_handle) ;  //      _Load   initcompar
	return r ;
}

int __cdecl comparCHAREXACT (Value FAR * pkey, Locator FAR * pbase) {
	int r = 0;
	long lenpkey, lenpbase, i ; 
	char FAR *p1, FAR *p2;
	Value  aVal ;
	initcompar(pbase, &aVal, 'C') ;
	
	//    ,        SET EXACT
	//   SET EXACT,  Comparison,        
	//      ,     ,    
	//             1
	if (pbase->l_offset == 1)  //     ascanquick
		LowerToUpper(&aVal) ;  //      
	
	//   
	lenpkey=pkey->ev_length ;
	lenpbase=aVal.ev_length ;
	_HLock(pkey->ev_handle) ;
	_HLock(aVal.ev_handle) ;
	
	
	//      
	p1 = (char FAR *)_HandToPtr(pkey->ev_handle) ;
	for (i=lenpkey;i>0 && *(p1+i-1)==SPACE32 ;i--) 
		;
	lenpkey=i ;
	
	//       
	p2 = (char FAR *)_HandToPtr(aVal.ev_handle) ;
	for (i=lenpbase;i>1 && *(p2+i-1)==SPACE32 ;i--)  //            ,      
		;
	lenpbase=i ;
	
	if (lenpkey<lenpbase) {
		r=_MemCmp((void FAR *)p1,(void FAR *)p2,lenpkey ) ;
		if (r==0)
			r=-1 ;
	}   
	else {
		if (lenpkey>lenpbase) {
			r=_MemCmp((void FAR *)p1,(void FAR *)p2,lenpbase ) ;
			if (r==0)
				r=1 ;
		}   
		else {
			r=_MemCmp((void FAR *)p1,(void FAR *)p2,lenpbase ) ;   
		}  
	}  
	//	}
	_HUnLock(pkey->ev_handle) ;
	_HUnLock(aVal.ev_handle) ;
	_FreeHand(aVal.ev_handle) ; //      _Load   initcompar
	
	return r ;
}


int __cdecl comparN ( Value FAR * pkey, Locator FAR * pbase) {
	Value  aVal ;
	double bkey, k ;
	initcompar(pbase,&aVal,0) ;
	
	if (pkey->ev_type=='I')
		k = (double)pkey->ev_long ;
	else if (pkey->ev_type == 'N')
		k = pkey->ev_real ;
	
	if (aVal.ev_type == 'I')
		bkey = (double) aVal.ev_long ;
	else if (aVal.ev_type == 'N')
		bkey = aVal.ev_real ;
#if VERSION == VFP
	else  if (aVal.ev_type == 'Y') { //     'Y'    'N', 'I'
		return comparNY( k, aVal.ev_currency )  ;	
	}
#endif
	else
		_Error(302) ; //   
	
	if  ( k > bkey )
		return 1 ;   
	else
		return ( (k < bkey )?-1:0) ;   
}


int __cdecl comparD ( Value FAR * pkey, Locator FAR * pbase) {
	Value  aVal ;
	initcompar(pbase,&aVal,0) ;
	
	if (!(aVal.ev_type == 'D') && !(aVal.ev_type == 'T'))
		_Error(302) ; //   
	
	if  (pkey->ev_real > aVal.ev_real )
		return 1 ;   
	else
		return ( pkey->ev_real < aVal.ev_real )?-1:0 ;   
}

int __cdecl comparL ( Value FAR * pkey, Locator FAR *  pbase) {
	Value  aVal ;
	initcompar(pbase, &aVal, 'L') ;
	return (int)( pkey->ev_length - aVal.ev_length ) ;
}

#if  VERSION == VFP 
int __cdecl comparY ( Value FAR * pkey, Locator FAR * pbase) {
	double bkey ;
	Value  aVal ;
	
	initcompar(pbase,&aVal, 0) ;
	if (aVal.ev_type == 'I')
		bkey = (double) aVal.ev_long ;
	else if (aVal.ev_type == 'N')
		bkey = aVal.ev_real ;
	else  if (aVal.ev_type == 'Y') { //     'N', 'I'     'Y'
		return comparYY(pkey->ev_currency , aVal.ev_currency) ;  
	}
	else
		_Error(302) ; //   
	
	return (-1)*comparNY(bkey, pkey->ev_currency)  ;	
}
#endif



/*   mybsearch1          
  ,        -   
	   Set Exact On 
	   -1           ,        
		 0           ,        
		                ,        
*/
long mybsearch1(Value FAR * key,		/* Key to be located */
				Locator FAR * pbase,
				long nel )		/* Number of elements in the table */
				
{
	long begin, base, last;
	int res ;
	long  i ; 
	Value  aVal ;
	char FAR *p1;
	
	p1 = (char FAR *)_HandToPtr(key->ev_handle) ; 	//   ,          
	for (i=key->ev_length;i>0 && *(p1+i-1)==SPACE32 ;i--) 
		;
	
	if (i)
		return -1L; //          ,        
	
	initcompar(pbase,&aVal,'C') ;
	i  = aVal.ev_length ; 	//   i   ,     _FreeHand  ,   if   
	_FreeHand(aVal.ev_handle) ;  //      _Load   initcompar
	if (!i) {  //       ,   
		return pbase->l_sub1 ; //  ,        (  )
	}
	
	/*    ,     ,   Set Exact Off,
	       ,        comparCHAR
	       0,        ,
	    ,             ,
	         ,          ,
	   ,   ,	  0        . */
	
	// Check to see if we can allocate the memory needed
	if ((aVal.ev_handle = _AllocHand(1)) == 0) {
		_Error(182);	// insufficient memory
	}
	aVal.ev_length = 1;
	//        
	*((char FAR *)_HandToPtr(aVal.ev_handle)) = SPACE32;
	
	if (nel == 0)
		return 0L;
	
	base = begin = pbase->l_sub1 ;    /* Beginning of table */
	last = base +  (nel - 1);
	
	while (last >= base) {
		pbase->l_sub1 =  (USHORT)(last + base)/2;
		res = ( *comparCHAR)(&aVal, pbase);
		if (res == 0) { /* Key found */
			do {   //            
				--(pbase->l_sub1) ;
				if (pbase->l_sub1<begin)
					break; 
			} while ((*comparCHAR)(&aVal, pbase) == 0) ;
			//       
			_FreeHand(aVal.ev_handle) ;  //      _AllocHand
			//           
			++pbase->l_sub1;	
			
			while (pbase->l_sub1 <= (begin + nel - 1)) {
				initcompar(pbase,&aVal,'C') ;
				_HLock(aVal.ev_handle) ;
				
				p1 = (char FAR *)_HandToPtr(aVal.ev_handle) ;
				if (*p1 != SPACE32) {
					_HUnLock(aVal.ev_handle) ;
					_FreeHand(aVal.ev_handle) ; //      _Load   initcompar
					return 0L;		/* Key not found */
				} 
				//       
				for (i= aVal.ev_length; i>0 && *(p1+i-1)==SPACE32 ;i--) 
					;
				_HUnLock(aVal.ev_handle) ;
				_FreeHand(aVal.ev_handle) ; //      _Load   initcompar
				if (!i)  //      
					return pbase->l_sub1;		/* Key found */
				++pbase->l_sub1;
			}
			
			if (pbase->l_sub1 > (begin + nel - 1)) {
				return 0L;		/* Key not found */
			}
		}
		if (res < 0)
			last = pbase->l_sub1 - 1;
		else
			base = pbase->l_sub1 + 1;
	}
	
	_FreeHand(aVal.ev_handle) ;  //      _AllocHand
	return 0L;		/* Key not found */
}



/*  nStartRow -  Specifies the row number at which the search begins.
The row number you specify is included in the search.
If you omit nStartRow, the entire array is searched by default.
nRowsSearched - Specifies the number of rows that are searched.
If you omit nStartRow and nRowsSearched, the search begins 
with the first array row and continues to the last array row.
NStartRow -   ,     .
  NStartRow    .
    nStartRow       .
  NRowsSearched -   ,    .
      nRowsSearched,       NStartRow      . */ 
	void FAR vitescan(ParamBlk FAR *parm) {
		long arsize, nRowsSearched, nColumnsSearched, nStartRow, nElemRow = 0 ;
		Value  HoldVal ;
		
		if ( (arsize=_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1))==-1) 
			_Error(232) ;  //   !
		
		parm->p[0].loc.l_subs = _ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT2)>0?2:1 ;
		
		if (parm->p[0].loc.l_subs == 2) {
			if (parm->pCount >= 3) { //     ?
				nColumnsSearched = parm->p[2].val.ev_long ;
				//    ,   , 
				if  ((nColumnsSearched > _ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT2)) || (nColumnsSearched<1) ) 
					_Error(234) ; //     
			}
			else 
				nColumnsSearched = 1 ; //      
			
			parm->p[0].loc.l_sub2 = (USHORT) nColumnsSearched ;
		}
		else 
			parm->p[0].loc.l_sub2 = 0 ;   //  
		
		if (parm->pCount >= 4) { //     ?
			nStartRow =  parm->p[3].val.ev_long ;
			if (nStartRow == -1)
				nStartRow = 1 ; //  -1    (   )
			//    ,   , 
			if  ((nStartRow>_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1)) || (nStartRow<1) )
				_Error(234) ; //     
		}
		else 
			nStartRow = 1 ; //      
		
		if (parm->pCount == 5) {
			//   ,     
			nRowsSearched =  parm->p[4].val.ev_long ;
			//   ,     -   
			//    ,     ,
			//   -             
			// -1    (     )
			if  ( (nRowsSearched == -1) ||  (nStartRow+nRowsSearched-1>_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1) ) )  
				nRowsSearched = arsize-nStartRow+1 ; 
			if  ( (nRowsSearched < -1) ||  (nRowsSearched == 0 ) )  
				_Error(234) ; //     
		}
		else //   -             
			nRowsSearched = arsize-nStartRow+1 ;
		
		if (nRowsSearched<1) //   ,        0
			goto SORTIR ;
		
		if (parm->p[1].loc.l_type == 'R')  // pass by reference
			_Load(&parm->p[1].loc, &HoldVal) ;
		else 
			_MemMove(&HoldVal, &parm->p[1].val, sizeof(Value)) ;
		
		
		switch(HoldVal.ev_type)
		{
		case 'T':
		case 'D':
		case 'N':
		case 'I':
			compar=(HoldVal.ev_type=='D'  || (HoldVal.ev_type == 'T'))?comparD:comparN ;
			break ;
#if  VERSION == VFP
		case 'Y':
			compar=comparY ;
			break ;
#endif
		case 'L':
			compar=comparL ;
			break ;
		case 'C':
			{   int errcode ;
			Value  TmpVal ;
			if ((errcode = _Evaluate(&TmpVal, "SET('EXAC')"))!=0) //    SET('EXAC') 
				_Error(errcode) ; // exits api
			_FreeHand(TmpVal.ev_handle) ; //  ,   _Evaluate
			// We now the current setting SET('EXACT') len=2 if 'ON', len=3 if 'OFF'
			//     SET('EXAC')    
			compar=(TmpVal.ev_length == 2)?comparCHAREXACT:comparCHAR ; 
			}
			//       ASORT()    St_Denis_Russian.chm  "", "   ..."
			//  ,  Set Exact On,       , 
			//         ,   , ASCII    32.
			//            Set Exact On,           
			if (compar == comparCHAREXACT) {
				parm->p[0].loc.l_sub1 = (USHORT)nStartRow ;
				nElemRow = mybsearch1(&HoldVal, &parm->p[0].loc, nRowsSearched) ; //   -1           
				if (nElemRow > -1)   //                     
					goto SORTIR ;
			}
			break ;
		default:
			break ;
		}
		
		/*	   bsearch       
		      65000 ,   
		  -     
		  -     Locator
		      ,         
		   l_sub1  Locator
		      -  ,      
		   -    */
		parm->p[0].loc.l_sub1 = (USHORT)nStartRow ;
		nElemRow = mybsearch(&HoldVal, &parm->p[0].loc, nRowsSearched, compar) ;
		
SORTIR:
		_RetInt(nElemRow, 10) ;
		
		if (parm->p[1].loc.l_type == 'R') // pass by reference
			if (HoldVal.ev_type=='C')
				_FreeHand(HoldVal.ev_handle) ; //      _Load
}





void FAR ascanquick(ParamBlk FAR *parm) {
	long arsize, nRowsSearched, nColumnsSearched, nStartRow, nElemRow = 0 ;
	char nFlags = 0 ; //    
	Value  HoldVal ;
	
	if ( (arsize=_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1))==-1) 
		_Error(232) ;  //   !
	parm->p[0].loc.l_subs = _ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT2)>0?2:1 ;
	
	if (parm->p[0].loc.l_subs == 2) { // 5-    (    ASCAN)
		if (parm->pCount >= 5) { //     ?
			nColumnsSearched =  parm->p[4].val.ev_long ;
			//    ,   , 
			if  ((nColumnsSearched>_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT2)) || (nColumnsSearched<1) ) 
				_Error(234) ; //     
		}
		else 
			nColumnsSearched = 1 ; //      
		
		parm->p[0].loc.l_sub2 = (USHORT)nColumnsSearched ;
	}
	else {
		parm->p[0].loc.l_sub2= 0 ;   //  
	}
	
	if (parm->pCount >= 3) { //     ?
		nStartRow = parm->p[2].val.ev_long ;
		if (nStartRow == -1)
			nStartRow = 1 ; //     ASCAN -1    (   )
		//    ,   , 
		if  ((nStartRow>_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1)) || (nStartRow<1) )
			_Error(234) ; //     
	}
	else 
		nStartRow = 1; //      
	
	if (parm->pCount >= 4) { //   ,     
		nRowsSearched =  parm->p[3].val.ev_long ;
		//   ,     -   
		//    ,     ,
		//   -             
		//     ASCAN -1    (     )
		if  ( (nRowsSearched == -1) ||  (nStartRow+nRowsSearched-1>_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1) ) )  
			nRowsSearched = arsize-nStartRow+1 ; 
		if  ( (nRowsSearched < -1) ||  (nRowsSearched == 0 ) )  
			_Error(234) ; //     
	}
	else //   -             
		nRowsSearched = arsize-nStartRow+1 ;
	
	if (parm->pCount == 6) { //   ,    ASCAN 
		nFlags  = (char) parm->p[5].val.ev_long ;
		if ( (int)nFlags  < 0 ||  (int)nFlags  > 15 )
			_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
	}
	
	/*  nFlags	The bit values are as follows:
	Bit Description 
	0   Case Insensitive bit  
	1   Exactness ON bit (Only effective if bit 2 is set) 
	2   Override system Exact setting bit 
	3   Return row number if 2D array 	*/ 
	
	if (nRowsSearched<1) //   ,        0
		goto SORTIR ;
	
	if (parm->p[1].loc.l_type == 'R')  // pass by reference
		_Load(&parm->p[1].loc, &HoldVal) ; //     
	else 
		_MemMove(&HoldVal, &parm->p[1].val, sizeof(Value)) ;
	
	//      'N', 'I', 'Y'       'N', 'I', 'Y'
	switch(HoldVal.ev_type)
	{
	case 'D':
	case 'T':
	case 'N':
	case 'I':
		compar=((HoldVal.ev_type=='D') || (HoldVal.ev_type == 'T') )?comparD:comparN ;
		break ;
	case 'L':
		compar=comparL ;
		break ;
#if  VERSION == VFP
	case 'Y':
		compar=comparY ;
		break ;
#endif
	case 'C':
		if ( (nFlags & 0x1) ) { //  Case Insensitive bit 
			//             1  	
			LowerToUpper(&HoldVal) ;  //      
			parm->p[0].loc.l_offset = 1; //   l_offset           
		}
		if ( (nFlags & 0x4) ) // Override system Exact setting bit 
			compar=(nFlags & 0x2)?comparCHAREXACT:comparCHAR ; //  nFlags & 0x2 Exactness ON bit (Only effective if bit 2 is set) 
		else { 
			int errcode ;
			Value  TmpVal ;
			if ((errcode = _Evaluate(&TmpVal, "SET('EXAC')"))!=0) //    SET('EXAC') 
				_Error(errcode) ; // exits api
			_FreeHand(TmpVal.ev_handle) ; //   ,   _Evaluate
			// We now the current setting SET('EXACT') len=2 if 'ON', len=3 if 'OFF'
			//     SET('EXAC')    
			compar=(TmpVal.ev_length == 2)?comparCHAREXACT:comparCHAR ; 
		}
		//       ASORT()    St_Denis_Russian.chm  "", "   ..."
		//  ,  Set Exact On,       , 
		//         ,   , ASCII    32.
		//            Set Exact On,           
		if (compar == comparCHAREXACT) {
			parm->p[0].loc.l_sub1 = (USHORT)nStartRow ; //     
			nElemRow = mybsearch1(&HoldVal, &parm->p[0].loc, nRowsSearched) ; //   -1           
			if (nElemRow > -1)   //             ,        
				goto SORTIR ;
		}
		break ;
	default:
		break ;
	}
	/*	   bsearch       
	      65000    
	     -     
	     -     Locator
		    ,         
		  l_sub1  Locator
		     -  ,      
	   -   	*/
	parm->p[0].loc.l_sub1 = (USHORT)nStartRow ; //     
	
	nElemRow = mybsearch(&HoldVal, &parm->p[0].loc, nRowsSearched, compar) ;
	
SORTIR:
	if  ((nFlags & 0x8) || (parm->p[0].loc.l_subs != 2))   // Return row number if 2D array 
		_RetInt(nElemRow, 10) ;
	else
		_RetInt( nElemRow ? ( nElemRow - 1) *_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT2) + nColumnsSearched :0, 10) ;
	
	if (parm->p[1].loc.l_type == 'R') // pass by reference
		if (HoldVal.ev_type=='C')
			_FreeHand(HoldVal.ev_handle) ; //      _Load
}

int ComparString ( Value FAR * pHoldVal, Value FAR * aVal, char ComparExact) {
	int r = 0 ;	
	
	_HLock(pHoldVal->ev_handle) ;
	_HLock(aVal->ev_handle) ;
	
	if (ComparExact) {
		unsigned int lenpkey,lenpbase,i ; 
		char FAR *p1;
		char FAR *p2;
		
		lenpkey=pHoldVal->ev_length ;  
		lenpbase=aVal->ev_length ;
		
		p1 = (char FAR *)_HandToPtr(pHoldVal->ev_handle) ; 
		/*
		for (i=lenpkey;i>0 && *(p1+i-1)==32 ;i--) //   
		;
		lenpkey=i ;
		*/
		
		p2 = (char FAR *)_HandToPtr(aVal->ev_handle) ;
		/*
		for (i=lenpbase;i>0 && *(p2+i-1)==32 ;i--) //   
		;
		lenpbase=i ;
		*/
		
		if (lenpkey==0 ) {  //      ,     ,    
			for (i=0; i<lenpbase  && r==0 ;i++) {  //  ,                 
				if ( (unsigned char)*(p2+i)>SPACE32 )
					r = -1;
				else  if ((unsigned char)*(p2+i)<SPACE32 ) 
					r = ( i < pHoldVal->ev_length ) ? -1: 1;  //    ,           ,     
			}
			if (r == 0 && pHoldVal->ev_length != aVal->ev_length )
				r = (pHoldVal->ev_length < aVal->ev_length) ? -1 : 1;                
		}
		else {
			if (lenpkey<lenpbase) {
				r=_MemCmp((void FAR *)p1,(void FAR *)p2,lenpkey ) ;
				if (r==0)
					r=-1 ;
			}   
			else {
				if (lenpkey>lenpbase) {
					r=_MemCmp((void FAR *)p1,(void FAR *)p2,lenpbase ) ;
					if (r==0)
						r=1 ;
				}   
				else {
					r=_MemCmp((void FAR *)p1,(void FAR *)p2,lenpbase ) ;   
				}  
			}  
		}
	}
	else {
		if (pHoldVal->ev_length < aVal->ev_length) {
			r=_MemCmp(_HandToPtr(pHoldVal->ev_handle),_HandToPtr(aVal->ev_handle),pHoldVal->ev_length ) ;
		}   
		else {
			if (pHoldVal->ev_length > aVal->ev_length) {
				r=_MemCmp(_HandToPtr(pHoldVal->ev_handle),_HandToPtr(aVal->ev_handle),aVal->ev_length ) ;
				if (r==0)
					r=1 ;
			}   
			else {
				r=_MemCmp(_HandToPtr(pHoldVal->ev_handle),_HandToPtr(aVal->ev_handle),pHoldVal->ev_length ) ;   
			}  
		}  
	}
	_HUnLock(pHoldVal->ev_handle) ;
	_HUnLock(aVal->ev_handle) ;
	return r ;
}

#if  VERSION == VFP
void FAR retcurr(double flt) {
	CCY money;
	double n;
	
	flt = modf( flt*10000.0, &n );   
	if (fabs(flt)>= 0.5)   /*  fractional part   */
		n += (n>=0)?1:-1;  /*  integer part   */
	
	money.HighPart = (long) floor(n/ pow(2,32));
	flt = fabs(n - (double)money.HighPart*pow(2,32));
	money.LowPart = (unsigned long) (n >= 0 ? ceil(flt): flt) ; 
	_RetCurrency(money,25);
}
#endif

#define FARRAYCOUNT   (char)1
#define FARRAYSUM     (char)2
#define FARRAYAVERAGE (char)3
#define FARRAYLOWEST  (char)4
#define FARRAYHIGHEST (char)5
#define FARRAYLOWESTORHIGHESTCARACTER (char)6
#define FARRAYLOWESTDATETIME  (char)7
#define FARRAYHIGHESTDATETIME (char)8

void FAR farray(ParamBlk FAR *parm, char what) {
	unsigned long nRowsSearched, nColumnsSearched  ;
	long i, Counter = 0, CounterDateTime = 0, CounterCaracter = 0, nStartRow ;
	int errcode ;
	double elem, minelem, maxelem, sumelem = 0, elemDateTime, minelemDateTime, maxelemDateTime ;
	long NumberOfElemMinDateTime = 0, NumberOfElemMaxDateTime = 0, NumberOfElemMin_or_MaxCaracter = 0;
	long NumberOfElemMax = 0, NumberOfElemMin = 0, NumberOfElem_maximal_or_Minimal = 0;
	char nFlags = 0, nFlagsHandMem = 0 ;
	Value min_or_max_Val, aVal;
	
	
	if ( (i=_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1))==-1)
		_Error(232) ;  //   !
	
	parm->p[0].loc.l_subs = _ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT2)>0?2:1 ;
	
	if (parm->p[0].loc.l_subs == 2) {
		if (parm->pCount >= 2) {
			nColumnsSearched = (long) parm->p[1].val.ev_long ; //     ?
			if (nColumnsSearched == - 1)
				nColumnsSearched = 1 ;
			//    ,   , 
			if  ((nColumnsSearched>(unsigned long)_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT2)) || (nColumnsSearched<1) ) 
				_Error(234) ; //     
		}
		else {
			nColumnsSearched=1 ; //      
		}  
		parm->p[0].loc.l_sub2= (short)nColumnsSearched ;
	}
	else {
		parm->p[0].loc.l_sub2=(short)0 ;   //  
	}
	if (parm->pCount >= 3) {
		nStartRow = (long) parm->p[2].val.ev_long ; //     ?
		if (nStartRow == - 1)
			nStartRow = 1 ;
		//    ,   , 
		if  ((nStartRow>_ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1)) || (nStartRow<1) )
			_Error(234) ; //     
	}
	else {
		nStartRow = (long) 1 ; //      
	}
	
	if (parm->pCount >= 4) {
		nRowsSearched = (long) parm->p[3].val.ev_long ; //   ,     
		//   ,     -   
		//    ,     ,
		//   -             
		if  ( (nStartRow+nRowsSearched-1) > (unsigned long) _ALen(parm->p[0].loc.l_NTI, AL_SUBSCRIPT1) || (nRowsSearched == -1) )
			nRowsSearched = i-nStartRow+1 ; 
	}
	else {
		//   -             
		nRowsSearched = i-nStartRow+1 ;
	}
	//   ,        FALSE
	nRowsSearched += nStartRow ;
	
	
	// 0x1,  0x2 , 0x4 , 0x8 , 0x10, 0x20, 0x40, 0x80    
	// 0xFE, 0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F   
	
	for (i = nStartRow; (unsigned long)i < nRowsSearched; i++ ) {
		parm->p[0].loc.l_sub1 = (USHORT) i ; //    
		
		if (errcode = _Load(&parm->p[0].loc, &aVal)) //    
			_Error(-errcode) ; // exits api
		
		if (aVal.ev_type == 'N' || aVal.ev_type == 'I' || aVal.ev_type == 'Y' ) {
			nFlags |= 0x1  ; //   -   ()  
			if (aVal.ev_type != 'Y')
				nFlags |= 0x2  ; //   -           
			if (aVal.ev_type == 'N') 
				elem = aVal.ev_real ;
			else if (aVal.ev_type == 'I' ) 
				elem = (double) aVal.ev_long ;
#if  VERSION == VFP
			else 
				elem = ((double)aVal.ev_currency.HighPart/10000.0) * pow(2,32) + fabs((double)aVal.ev_currency.LowPart/10000.0);
#endif
		}
		else  {   
			nFlags &= 0xFE ; //       
			if (aVal.ev_type == 'C') {
				nFlags |= 0x20  ; //   -    
				nFlagsHandMem |= 0x20  ; //     aVal.ev_handle
				nFlags &= 0xEF ; //          
			}
			else {
				nFlags &= 0xDF ; //      
				if (aVal.ev_type == 'D' || aVal.ev_type == 'T') {
					nFlags |= 0x10  ; //   -       
					if (aVal.ev_type == 'T')
						nFlags |= 0x40  ; //   -     (   )
					elemDateTime = aVal.ev_real ;
				} 
				else
					nFlags &= 0xEF ; //           
			}
		} 
		if ( nFlags & 0x1 ) {
			if ( !Counter ) { 
				minelem = maxelem = elem ;
				NumberOfElemMin = NumberOfElemMax = i  ;
				nFlags &= 0xDF ; //       
				nFlags &= 0xEF ; //          , 
			}
			else {
				if ( elem > maxelem ) {
					NumberOfElemMax = i ;
					maxelem = elem ;
				}
				else if ( elem < minelem ) {
					NumberOfElemMin = i ; 
					minelem = elem ;
				}  
			}
			sumelem += elem ;
			Counter++ ; //    
		}
		else {  //        ,  !Counter
			//        
			if (!Counter && (what == FARRAYLOWEST || what == FARRAYHIGHEST) ) {
				//        SET('EXACT')
				if ( nFlags & 0x20 ) {  //   
					if ( !CounterCaracter ) {
						min_or_max_Val.ev_type =  'C' ;
						min_or_max_Val.ev_length = aVal.ev_length ;
						min_or_max_Val.ev_handle = aVal.ev_handle ;
						nFlagsHandMem &= 0xDF ; //       aVal.ev_handle
						nFlagsHandMem |= 0x40  ; //   -       , 
						NumberOfElemMin_or_MaxCaracter = i  ;
						{	Value  TmpVal ;
						if ((errcode = _Evaluate(&TmpVal, "SET('EXAC')"))!=0) //    SET('EXAC') 
							_Error(errcode) ; // exits api
						_FreeHand(TmpVal.ev_handle) ; //   ,   _Evaluate
						// len=2 if 'ON', len=3 if 'OFF'
						//     SET('EXAC')    
						if (TmpVal.ev_length == 2)
							nFlags |= 0X80  ; //   - SET('EXACT') is ON
						else
							nFlags &= 0x7F ; //      SET('EXACT') is ON
						}
					}
					else {
						if (ComparString(what == FARRAYLOWEST ? &min_or_max_Val : &aVal, what == FARRAYLOWEST ? &aVal  : &min_or_max_Val, (char) (nFlags & 0x80 ? 1: 0) ) > 0) {
							_FreeHand(min_or_max_Val.ev_handle) ; //        
							min_or_max_Val.ev_length = aVal.ev_length ;
							min_or_max_Val.ev_handle = aVal.ev_handle ;
							nFlagsHandMem &= 0xDF ; //       aVal.ev_handle
							NumberOfElemMin_or_MaxCaracter = i  ;
						}
					}
					CounterCaracter++ ; //    
				}
				
				if ( !CounterCaracter) {  //          !CounterCaracter
					if ( nFlags & 0x10 ) {  //     
						if ( !CounterDateTime ) { 
							minelemDateTime = maxelemDateTime = elemDateTime ;
							NumberOfElemMaxDateTime = NumberOfElemMinDateTime = i  ;
						}
						else {
							if ( elemDateTime > maxelemDateTime ) {
								NumberOfElemMaxDateTime = i ;
								maxelemDateTime = elemDateTime ;
							} 
							else if ( elemDateTime < minelemDateTime ) {
								NumberOfElemMinDateTime = i ; 
								minelemDateTime = elemDateTime ;
							}
						}
						CounterDateTime++ ; //      
					}
				}
				
			}
		}
		if ( nFlagsHandMem & 0x20 ) { //  ,     
			_FreeHand(aVal.ev_handle) ; //   
			nFlagsHandMem &= 0xDF ; //       aVal.ev_handle
		} 
	} 
	//    (    )
	//             
	if ( !Counter ) { 
		if ( CounterCaracter && (what == FARRAYLOWEST || what == FARRAYHIGHEST) ) {
			what =  FARRAYLOWESTORHIGHESTCARACTER ;
			aVal.ev_type = 'C' ;
		}
		else {
			if ( CounterDateTime && (what == FARRAYLOWEST || what == FARRAYHIGHEST) ) {
				what =  (what == FARRAYLOWEST) ? FARRAYLOWESTDATETIME :  FARRAYHIGHESTDATETIME ;
				aVal.ev_type = ( nFlags & 0x80 ) ? 'T': 'D' ; 
			}
			else
				if (what != FARRAYCOUNT ) 
					what = '0' ;   //      
		} 
	}
	switch(what) {
	case FARRAYCOUNT:
		_RetInt(Counter, 10) ;  // Count
		break ;
	case FARRAYSUM:
		if ( nFlags & 0x2 )
			_RetFloat(sumelem, 20, 10) ;  // Sum
#if  VERSION == VFP
		else 
			retcurr(sumelem);
#endif
		break ;       
	case FARRAYAVERAGE:
		sumelem/=(double)Counter; //      
		if ( nFlags & 0x2 ) 
			_RetFloat(sumelem, 20, 10) ;  // Average
#if  VERSION == VFP
		else 
			retcurr(sumelem);
#endif
		break ;       
	case FARRAYLOWEST:
		NumberOfElem_maximal_or_Minimal = NumberOfElemMin ;
		if ( nFlags & 0x2 )
			_RetFloat(minelem, 20, 10) ;  // Lowest
#if  VERSION == VFP
		else 
			retcurr(minelem);
#endif
		break ;       
	case FARRAYHIGHEST:
		NumberOfElem_maximal_or_Minimal = NumberOfElemMax ;
		if ( nFlags & 0x2 )
			_RetFloat(maxelem, 20, 10) ;  // Highest
#if  VERSION == VFP
		else 
			retcurr(maxelem); 
#endif
		break ;       
	case FARRAYLOWESTORHIGHESTCARACTER:
		NumberOfElem_maximal_or_Minimal = NumberOfElemMin_or_MaxCaracter ;
		nFlagsHandMem &= 0xBF ;    //     ,         , 
		_RetVal(&min_or_max_Val) ; // Lowest or  Highest for caracter
		break ;       
	case FARRAYLOWESTDATETIME:
		NumberOfElem_maximal_or_Minimal = NumberOfElemMinDateTime ;
		aVal.ev_real = minelemDateTime ;
		if ( nFlags & 0x40 )
			aVal.ev_type = 'T';
		_RetVal(&aVal) ; // Lowest for Date or DatTime
		break ;       
	case FARRAYHIGHESTDATETIME:
		NumberOfElem_maximal_or_Minimal = NumberOfElemMaxDateTime ;
		aVal.ev_real = maxelemDateTime ;
		if ( nFlags & 0x40 )
			aVal.ev_type = 'T';
		_RetVal(&aVal) ; // Highest for Date or DatTime
		break ;  
	default:
		_RetNULL(VERSION)
			break ;
	}
	
	if ( nFlagsHandMem & 0x40 ) //  ,         , 
		_FreeHand(min_or_max_Val.ev_handle) ; //   
	
	if (parm->pCount == 5) {
		Value aVal2  ;
		if (errcode = _Load(&parm->p[4].loc, &aVal2)) 
			_Error(-errcode) ; // exits api
		if (aVal2.ev_type == 'C') 
			_FreeHand(aVal2.ev_handle) ; //                    
		
		aVal2.ev_type = 'I' ;
		aVal2.ev_long =  NumberOfElem_maximal_or_Minimal ;
		
		//             
		//     (     ),   0
		if (errcode = _Store(&parm->p[4].loc, &aVal2)) 
			_Error(-errcode) ; // exits api
	}  
}

void FAR arraycnt(ParamBlk FAR *parm) {	farray(parm, FARRAYCOUNT)  ;}
void FAR arraysum(ParamBlk FAR *parm) {	farray(parm, FARRAYSUM)    ;}
void FAR arrayavg(ParamBlk FAR *parm) {	farray(parm, FARRAYAVERAGE);}
void FAR arraymin(ParamBlk FAR *parm) {	farray(parm, FARRAYLOWEST) ;}
void FAR arraymax(ParamBlk FAR *parm) {	farray(parm, FARRAYHIGHEST);}


//--------------- Begin strfilter, strpreparation ----------------------------

//-----------------------------------------------------------
//--     [1-9]   [123456789]
//--     [z-a]   [zyxwvutsrqponmlkjihgfedcba]
//--      255    
//-----------------------------------------------------------
void FAR  strpreparation(ParamBlk FAR *parm) {
	char filt[MAXBREAK];
	char filt1[MAXBREAK];
	unsigned char j, beg, end;
	char  *p;
	int i = 0, len = min(parm->p[0].val.ev_length,MAXBREAK);
	
	_MemMove(filt,_HandToPtr(parm->p[0].val.ev_handle),len);
	filt[len] = '\0';
	len--;
	
	for (p = filt; *p && i<(MAXBREAK-1) ;  p++) {
		if (*p == '-' && p > filt && p < (filt+len)) {
			beg = (unsigned char)*(p-1);
			end = (unsigned char)*(p+1);
			if (end > beg) {
				for (j = beg+1; j < end && i<(MAXBREAK-1); j++) 
					filt1[i++] =  j;
			}
			else {
				if (end < beg) {
					for (j = beg-1; j > end && i<(MAXBREAK-1); j--) 
						filt1[i++] =  j;
				}
			}
			if (end == '-' && i<(MAXBREAK-1))  // '-'
				filt1[i++] = *(++p); //     "--" ,    "-"    
		}
		else
			filt1[i++] = *p;  
	}
	
	filt1[i]='\0';
	
	_RetChar((char FAR *)filt1);
}

//--------------------------------------------------------------------------
void FAR  strfilter(ParamBlk FAR *parm)
//--------------------------------------------------------------------------
// Filter out any characters that aren't in filt_str.
// Usage:   strfilter(string, filt_str)
// Returns: string
// Author:  Igor Nikiforov History: Initially written August 11, 2006
//--------------------------------------------------------------------------
{
	char filt[MAXBREAK];
	MHANDLE t;
	char FAR *p, *q;
	
	_MemMove(filt,_HandToPtr(parm->p[1].val.ev_handle),min(parm->p[1].val.ev_length,MAXBREAK));
	filt[min(parm->p[1].val.ev_length,MAXBREAK)] = '\0';
	
	t = gethandle(parm, 0);
	if (t == 0) 
		_Error(302);	// Data type mismatch
	
	for ( q = p = _HandToPtr(t); *p ; p++) 
		if ( strchr(filt,*p) != NULL) 
			*q++ = *p;
		
		*q =  '\0';   /* _RetChar() needs null terminated string */
		
		_HLock(t);    /* Lock MHANDLE during callback. */
		_RetChar(_HandToPtr(t));
		_HUnLock(t);
		if (parm->p[0].val.ev_type != 'C') // we must not free handles passed to them in their ParamBlk !
			_FreeHand(t);  /* Free MHANDLEs we allocate, but not handles passed in ParamBlk. */
}
//--------------- End strfilter, strpreparation ----------------------------


// function which accepts a string parameter and returns that string reversed
void FAR reverse(ParamBlk FAR *parm)  {
	register char Buffer;
	char FAR * string;
	unsigned long i, j = parm->p[0].val.ev_length - 1;
	/*  Since this routine does not call any functions which cause memory
	reorganization, it is not necessary to _HLock the handles prior to	dereferencing them (_HandToPtr) */
	string = (char FAR *)_HandToPtr(parm->p[0].val.ev_handle);
	for (i = 0; i < parm->p[0].val.ev_length/2 ; i++) {
		Buffer = *(string+i);
		*(string+i) = *(string+j-i);
		*(string+j-i) = Buffer;
	}
	_RetVal(&parm->p[0].val);
}


// ---------------- Begin  Working with windows ----------------------------
// *------------------------------------------------
//   ,  WHANDLE        
WHANDLE FindWhandle(ParamBlk FAR *parm, int pnum) {
	WHANDLE wh = 0 ;
	//   pnum   WHANDLE   ,   pnum  
	if (parm->pCount == pnum) {
		NullTerminate(&parm->p[pnum-1].val);     // Convert to ASCIIZ
		_HLock(parm->p[pnum-1].val.ev_handle);   // Lock string passed value  	
		wh = _WFindTitle((char FAR *) _HandToPtr(parm->p[pnum-1].val.ev_handle));
		_HUnLock(parm->p[pnum-1].val.ev_handle);
	}
	if  ( !wh )  //  pnum         
		wh=_WOnTop() ; 
	
	return wh ;   
}

//      ( ,    )
//           12.07.2004
void FAR SayInWindow(ParamBlk FAR *parm)  {
	Point pt;
	int i, j ;
	WHANDLE wh = 0 ;
	//            SAY
	i = (int) parm->p[0].val.ev_long;
	j = (int) parm->p[1].val.ev_long;
	
	//            
	NullTerminate(&parm->p[2].val);     // Convert to ASCIIZ
	_HLock(parm->p[2].val.ev_handle);   // Lock string passed value
	//      WHANDLE   ,     
	wh = FindWhandle(parm, 4) ;
	
	if ( i > (int)_WHeight( wh))
		i = 0 ;  
	if ( j > (int)_WWidth( wh))
		j = 0 ;  
	
	pt.v = i;
	pt.h = j;
	_WPosCursor(wh, pt); //     
	
	//          
	_WPutStr( wh, (char FAR *) _HandToPtr(parm->p[2].val.ev_handle)) ;
	_HUnLock(parm->p[2].val.ev_handle);
}

void FAR SetWindowsTitle(ParamBlk FAR *parm)  {
	WHANDLE wh = 0 ;
	
	NullTerminate(&parm->p[0].val);     // Convert to ASCIIZ
	_HLock(parm->p[0].val.ev_handle);   // Lock string passed value
	
	//      WHANDLE   ,        
	wh = FindWhandle(parm, 3) ;
	
	//          
	//          
	if ( parm->pCount == 1  ||  ( parm->pCount > 1  &&  parm->p[1].val.ev_length == 0) ) 
		_WSetTitle(wh, (char FAR *)_HandToPtr(parm->p[0].val.ev_handle));
	else
		_WSetFooter(wh, (char FAR *)_HandToPtr(parm->p[0].val.ev_handle));
	
	_HUnLock(parm->p[0].val.ev_handle);
}
// ---------------- End  Working with windows ----------------------------


// Returns the field number, referenced by name of a field, in a table.
void FAR fieldnum(ParamBlk FAR *parm) {
	int i=0 ;
	MHANDLE mh;
	NTI nti;
	
	NullTerminate(&parm->p[0].val);    // Convert to ASCIIZ
	_HLock(parm->p[0].val.ev_handle);   // Lock string passed value
	if ((mh = _AllocHand((int) parm->p[0].val.ev_length + 1)) == 0)  // Check to see if we can allocate the memory needed
		_Error(182);  // "Insufficient memory"
	_HLock(mh);
	_MemFill((char FAR *)_HandToPtr(mh), 0, (int) parm->p[0].val.ev_length+1);
	k_alltrim((char FAR *) _HandToPtr(parm->p[0].val.ev_handle), (char FAR *) _HandToPtr(mh)) ;  //  removes all leading and trailing spaces   ( )
	_StrCpy((char FAR *) _HandToPtr(parm->p[0].val.ev_handle),(char FAR *)_HandToPtr(mh)) ;
	_HUnLock(mh);
	_FreeHand(mh);
	
	//     -      
	if (parm->pCount > 1) {      // Specifies the alias of the table or the work area 
		if (parm->p[1].val.ev_type == 'I' || parm->p[1].val.ev_type == 'N') 
			i = (parm->p[1].val.ev_type == 'I') ? (int)parm->p[1].val.ev_long : (int)parm->p[1].val.ev_real ;
		else	{
			if (parm->p[1].val.ev_type == 'C') {
				Value val;
				NullTerminate(&parm->p[1].val);    // Convert to ASCIIZ
				_HLock(parm->p[1].val.ev_handle);   // Lock string passed value
				if ((mh = _AllocHand((int) parm->p[1].val.ev_length + 9)) == 0) // for "SELE([])"+'\0'
					_Error(182);  // "Insufficient memory"
				_HLock(mh);
				_MemFill((char FAR *)_HandToPtr(mh), 0, (int) parm->p[1].val.ev_length+9);
				_StrCpy((char FAR *)_HandToPtr(mh),"SELE([") ; 
				k_alltrim((char FAR *) _HandToPtr(parm->p[1].val.ev_handle), (char FAR *)_HandToPtr(mh)+6) ;  //  removes all leading and trailing spaces 
				_StrCpy((char FAR *)_HandToPtr(mh)+_StrLen((char FAR *)_HandToPtr(mh)),"])") ;
				if ((i = _Evaluate(&val, (char FAR *) _HandToPtr(mh)))!=0)  // returns the number of the currently selected work area 
					_Error(i) ; 
				_HUnLock(mh);
				_FreeHand(mh);
				_HUnLock(parm->p[1].val.ev_handle); // unlock string
				if (val.ev_type == 'I')
					i = (int)val.ev_long ;
				else if (val.ev_type == 'N')
					i = (int)val.ev_real ;
				
				// If where is - 1, nti is assumed to be a memory variable.
				// If where is 0, the current work area is checked for a field with the specified NTI.
				if (i==0)
					i = -2;  // alias not found  
			}
			else
				_Error(302);	// Data type mismatch
		}
	}
	
	if ((nti = _NameTableIndex((char FAR *) _HandToPtr(parm->p[0].val.ev_handle))) == -1) 
		_RetInt( 0, 10) ;  // the name of the field is not found (     )
	else  {
		Locator loc;  //     0,     
		_RetInt( _FindVar(nti, i , &loc) ? loc.l_offset+1 : 0 , 10) ;  // Returns the field number or returns zero if you specify a table alias that does not exist
	}
	_HUnLock(parm->p[0].val.ev_handle);   // unlock string
}

void FAR increment(ParamBlk FAR *parm) {
	// function increment
	// parameters pNumber, pnStep
	// pNumber = pNumber + iif (type([pnStep])==[N], pnStep, 1)
	// return pNumber
	
	Value val ;
	
	FillVal(parm, &val, 0) ;
	
	if (parm->pCount > 1) {
		if (val.ev_type == 'I')
			val.ev_long += parm->p[1].val.ev_long ;
		else if (val.ev_type == 'N')
			val.ev_real += parm->p[1].val.ev_long ;
	}
	else {
		if (val.ev_type == 'I')
			val.ev_long++ ;
		else if (val.ev_type == 'N')
			val.ev_real++ ;
	}
	
	_Store(&parm->p[0].loc, &val) ; //            
	_RetVal(&val) ; 
}


//--------------- Begin ifor, iwhile, iexeccase,  iexecif, execute ----------------------------
void FAR  MyError2(int errcode,MHANDLE lhandle) {
	_HUnLock(lhandle);
	_RetLogical(0) ;
	if (errcode==1098)
		_UserError("Wrong first parameter! Example: 'I=0' ") ;
	else
		_Error(errcode);
}

//  
void k_cntdelimiter(char FAR * ps,  unsigned int * CntofStr,  unsigned char * CntofString) {
	char j = 0 ;
	CntofStr[0] = 0 ;  
	
	while (j=k_at(ps+j,';')) { 
		j = j + CntofStr[(*CntofString)-1] ;
		CntofStr[(*CntofString)] = j ;
		(*CntofString) ++ ;
	}
}

//    k_execute  0,     FoxPro
//        
int k_execute(char FAR * ps, unsigned int * CntofStr, unsigned char CntofString, char jf) {
	char j ;
	int errcode ;
	for(j=jf; j<CntofString; j++) { 
		if ( (j + 1) < CntofString)
			*(ps + CntofStr[j+1] - 1) = '\0';       
		if ((errcode = _Execute(ps + CntofStr[j]))!=0) 
			return errcode;
	}    
	return 0;
}


void FAR ifor(ParamBlk FAR *parm)  {
	Value  HoldVal, saveHoldVal ;
	Locator ploc ;
	long i,fi,li,step ;
	char j ;
	int errcode = 0 ;
	char FAR * ps ;
	NTI var_exist ;
	char yes_var = 0 ;		
	char NameofVar[255];
	unsigned int CntofStr[255];
	unsigned char CntofString = 1 ;
	
	_MemFill(&HoldVal, 0, sizeof(Value)) ;
	ploc.l_subs = ploc.l_sub1 = ploc.l_sub2 = 0;
	
	//     FOR 
	li = (parm->p[1].val.ev_type == 'I') ? parm->p[1].val.ev_long : (long) parm->p[1].val.ev_real ;
	
	if (parm->pCount >= 4)  //   FOR  
		step = (parm->p[3].val.ev_type == 'I') ? parm->p[3].val.ev_long : (long) parm->p[3].val.ev_real  ;
	else        
		step = 1 ;
	
	NullTerminate(&parm->p[0].val);     // Convert to ASCIIZ
	NullTerminate(&parm->p[2].val);     // Convert to ASCIIZ
	_HLock(parm->p[0].val.ev_handle);   // Lock string passed value
	
	ps = _HandToPtr(parm->p[0].val.ev_handle);
	
	k_cntdelimiter(ps, CntofStr, &CntofString) ;
	if (CntofString > 1) {
		*(ps + CntofStr[1] - 1) = '\0';
		if ((errcode=k_execute(ps, CntofStr, CntofString, (char)1))!=0)
			MyError2(errcode, parm->p[0].val.ev_handle);
	}
	CntofString = 1 ;
	
	if (j=k_at(ps,'=')) { 
		fi = strtol( ps+j, NULL, 10 );   //     FOR 
		*(ps+j-1)='\0' ;
	}
	else 
		MyError2(1098,parm->p[0].val.ev_handle)  ;
	
	k_alltrim(ps,(char FAR *)NameofVar) ;  //   
	_HUnLock(parm->p[0].val.ev_handle);
	
	if ( (var_exist = _NameTableIndex((char FAR *)NameofVar)) > -1) {  // checking for exist of variable
		if (_FindVar(var_exist, -1, &ploc)) {
			if (ploc.l_subs == 0) { // this is variable or array ?
				if ( (errcode = _Load(&ploc, &saveHoldVal)) != 0)
					_Error(-errcode);
				yes_var = 1 ;
			}		
			else {
				ploc.l_subs = ploc.l_sub1 = ploc.l_sub2 = 0; //  _NewVar   ,  
				if ((errcode =_Release(var_exist))!=0) //       
					_Error(errcode);
			}
		}		
	}
	
	if (!yes_var)  // create the variable
		if ( (var_exist =_NewVar((char FAR *)NameofVar, &ploc, NV_PUBLIC ))<0) 
			_Error(var_exist);
		
		_HLock(parm->p[2].val.ev_handle);   // Lock string passed value
		
		ps = _HandToPtr(parm->p[2].val.ev_handle);
		
		k_cntdelimiter(ps, CntofStr, &CntofString) ;
		
		HoldVal.ev_type='I'  ;
		HoldVal.ev_width=20 ;
		
		if ( (fi<=li && step>=1) || (fi>=li && step<=-1)) {
			for(i=fi; (fi==li) ? i==li : (fi>li) ? i>=li : i<=li ; i+=step) {  // execute FOR cycle
				HoldVal.ev_long=i ;
				if ((errcode = _Store(&ploc, &HoldVal))!=0) 
					goto IFORSORTIR ; //  ,    
				// _Dialog (4,(char FAR *)NameofVar,"Continue",(char FAR *)0, (char FAR *)0, 1, 1);
				if ((errcode=k_execute(ps, CntofStr, CntofString, (char)0))!=0) {
					//  ,       , 
					//     ,        
					//   saveHoldVal.ev_handle   _Load      
					_HUnLock(parm->p[2].val.ev_handle);
					goto IFORSORTIR ; //  ,    
				}
			} 
		}    
		_HUnLock(parm->p[2].val.ev_handle);
		
		if (parm->pCount == 5) { // we must return the result
			NullTerminate(&parm->p[4].val);     // Convert to ASCIIZ   
			_HLock(parm->p[4].val.ev_handle);
			if ((errcode=_Evaluate(&HoldVal, (char FAR *)_HandToPtr(parm->p[4].val.ev_handle)))!=0) {
				_HUnLock(parm->p[4].val.ev_handle);
				goto IFORSORTIR ; //  ,    
			}
			else	 
				_RetVal(&HoldVal) ;
			_HUnLock(parm->p[4].val.ev_handle);
		}
		else
			_RetLogical(1) ;
		
IFORSORTIR:
		if (!yes_var)
			_Release(var_exist) ;
		else {
			if (_FindVar(var_exist, -1, &ploc) == TRUE) {
				int errcode1 = 0 ;
				if ((errcode1 = _Store(&ploc, &saveHoldVal))!=0)  // restore variable
					if (errcode == 0)
						_Error(-errcode1);  //    
					if (saveHoldVal.ev_type == 'C') 
						_FreeHand(saveHoldVal.ev_handle) ; //                    
			}
		}
		
		if (errcode!=0)
			_Error(errcode);
		return;
}

void FAR iwhile(ParamBlk FAR *parm)  {
	Value  HoldVal ;
	int errcode ;
	char FAR * ps ;
	unsigned int CntofStr[255] ;
	unsigned char CntofString = 1 ;
	
	NullTerminate(&parm->p[0].val);     // Convert to ASCIIZ
	NullTerminate(&parm->p[1].val);     // Convert to ASCIIZ
	
	_HLock(parm->p[0].val.ev_handle);   // Lock string passed value
	_HLock(parm->p[1].val.ev_handle);   // Lock string passed value
	
	ps = _HandToPtr(parm->p[0].val.ev_handle);
	k_cntdelimiter(ps, CntofStr, &CntofString) ;
	
	if (CntofString > 1) {
		*(ps + CntofStr[1] - 1) = '\0';
		if ((errcode=k_execute(ps, CntofStr, CntofString, (char)1))!=0)
			MyError2(errcode, parm->p[0].val.ev_handle);
	}
	CntofString = 1 ;
	
	ps = _HandToPtr(parm->p[1].val.ev_handle);
	k_cntdelimiter(ps, CntofStr, &CntofString) ;
	
	if ((errcode=_Evaluate(&HoldVal, (char FAR *)_HandToPtr(parm->p[0].val.ev_handle)))!=0)
		MyError2(errcode, parm->p[0].val.ev_handle);
	
	while ( HoldVal.ev_length == TRUE)  {  // execute WHILE cycle
		if ((errcode=k_execute(ps, CntofStr, CntofString, (char)0))!=0)
			MyError2(errcode, parm->p[1].val.ev_handle);
		if ((errcode=_Evaluate(&HoldVal, (char FAR *)_HandToPtr(parm->p[0].val.ev_handle)))!=0)
			MyError2(errcode, parm->p[0].val.ev_handle);
	} 
	_HUnLock(parm->p[0].val.ev_handle);
	_HUnLock(parm->p[1].val.ev_handle);
	
	if (parm->pCount == 3) { // we must return the result
		NullTerminate(&parm->p[2].val);    // Convert to ASCIIZ   
		_HLock(parm->p[2].val.ev_handle);  // Lock string passed value
		if ((errcode=_Evaluate(&HoldVal, (char FAR *)_HandToPtr(parm->p[2].val.ev_handle)))!=0)
			MyError2(errcode, parm->p[2].val.ev_handle);
		else
			_RetVal(&HoldVal) ;
		_HUnLock(parm->p[2].val.ev_handle);
	}
	else
		_RetLogical(1) ;
	
	return;
}

void FAR execute(ParamBlk FAR *parm)  {
	char FAR * ps ;
	unsigned int CntofStr[255] ;
	unsigned char CntofString = 1 ;
	int errcode ;
	
	NullTerminate(&parm->p[0].val);     // Convert to ASCIIZ
	_HLock(parm->p[0].val.ev_handle);   // Lock string passed value
	
	ps = _HandToPtr(parm->p[0].val.ev_handle) ;
	k_cntdelimiter(ps, CntofStr, &CntofString) ;
	if ((errcode=k_execute(ps, CntofStr, CntofString, (char)0))!=0)
		MyError2(errcode, parm->p[0].val.ev_handle);
	_HUnLock(parm->p[0].val.ev_handle);
	
	if (parm->pCount == 2) { // we must return the result
		Value  HoldVal ;
		NullTerminate(&parm->p[1].val);     // Convert to ASCIIZ   
		_HLock(parm->p[1].val.ev_handle);   // Lock string passed value
		if ((errcode=_Evaluate(&HoldVal, (char FAR *)_HandToPtr(parm->p[1].val.ev_handle)))!=0)
			MyError2(errcode, parm->p[1].val.ev_handle);
		else
			_RetVal(&HoldVal) ;
		_HUnLock(parm->p[1].val.ev_handle);
	}
	else
		_RetLogical(1) ;
	
	return;
}


void FAR iexeccase(ParamBlk FAR *parm)  {
	unsigned char i;
	char FAR * ps ;
	unsigned int CntofStr[255] ;
	unsigned char CntofString = 1 ;
	int errcode ;
	Value result;
	
	for (i=0 ;i<parm->pCount - (parm->pCount%3); i+=3) {
		if (parm->p[i].val.ev_type=='L') {
			if (parm->p[i].val.ev_length) {
				NullTerminate(&parm->p[i+1].val);     // Convert to ASCIIZ
				_HLock(parm->p[i+1].val.ev_handle);   // Lock string passed value
				ps = _HandToPtr(parm->p[i+1].val.ev_handle) ;
				k_cntdelimiter(ps, CntofStr, &CntofString) ;
				if ((errcode=k_execute(ps, CntofStr, CntofString, (char)0))!=0) // execute commands
					MyError2(errcode, parm->p[i+1].val.ev_handle);
				_HUnLock(parm->p[i+1].val.ev_handle);
				NullTerminate(&parm->p[i+2].val);     // Convert to ASCIIZ       
				_HLock(parm->p[i+2].val.ev_handle);   // Lock string passed value            	         
				if ((errcode=_Evaluate(&result, (char FAR *) _HandToPtr(parm->p[i+2].val.ev_handle)))!=0)
					MyError2(errcode, parm->p[i+2].val.ev_handle);
				else
					_RetVal(&result);
				_HUnLock(parm->p[i+2].val.ev_handle);
				return;
			}
		}
		else
			_Error(302);	// Data type mismatch
	}
	if ((parm->pCount%3) > 0) { // execute the "otherwise" condition if found
		i = parm->pCount - (parm->pCount%3)-1;
		NullTerminate(&parm->p[i+1].val);     // Convert to ASCIIZ
		_HLock(parm->p[i+1].val.ev_handle);   // Lock string passed value
		ps = _HandToPtr(parm->p[i+1].val.ev_handle) ;
		k_cntdelimiter(ps, CntofStr, &CntofString) ;
		if ((errcode=k_execute(ps, CntofStr, CntofString, (char)0))!=0) // execute commands
			MyError2(errcode, parm->p[i+1].val.ev_handle);
		_HUnLock(parm->p[i+1].val.ev_handle);
		if ((parm->pCount%3) == 2) {  // return the "otherwise" argument if found
			NullTerminate(&parm->p[i+2].val);     // Convert to ASCIIZ       
			_HLock(parm->p[i+2].val.ev_handle);   // Lock string passed value            	         
			if ((errcode=_Evaluate(&result, (char FAR *) _HandToPtr(parm->p[i+2].val.ev_handle)))!=0)
				MyError2(errcode, parm->p[i+2].val.ev_handle);
			else
				_RetVal(&result);
			_HUnLock(parm->p[i+2].val.ev_handle);
			return;
		}
	}   
	_RetNULL(VERSION)  // or .NULL. for VFP
		return;
}

void FAR iexecif(ParamBlk FAR *parm)  {
	char FAR * ps ;
	unsigned int CntofStr[255] ;
	unsigned char CntofString = 1 ;
	int errcode ;
	Value result;
	
	if (parm->p[0].val.ev_length) {
		NullTerminate(&parm->p[1].val);     // Convert to ASCIIZ
		_HLock(parm->p[1].val.ev_handle);   // Lock string passed value
		ps = _HandToPtr(parm->p[1].val.ev_handle) ;
		k_cntdelimiter(ps, CntofStr, &CntofString) ;
		if ((errcode=k_execute(ps, CntofStr, CntofString, (char)0))!=0) // execute commands
			MyError2(errcode, parm->p[1].val.ev_handle);
		_HUnLock(parm->p[1].val.ev_handle);
		NullTerminate(&parm->p[2].val);     // Convert to ASCIIZ       
		_HLock(parm->p[2].val.ev_handle);   // Lock string passed value            	         
		if ((errcode=_Evaluate(&result, (char FAR *) _HandToPtr(parm->p[2].val.ev_handle)))!=0)
			MyError2(errcode, parm->p[2].val.ev_handle);
		else
			_RetVal(&result);
		_HUnLock(parm->p[2].val.ev_handle);
		return;
	}
	else 
		if (parm->pCount > 3) {
			NullTerminate(&parm->p[3].val);     // Convert to ASCIIZ
			_HLock(parm->p[3].val.ev_handle);   // Lock string passed value
			ps = _HandToPtr(parm->p[3].val.ev_handle) ;
			k_cntdelimiter(ps, CntofStr, &CntofString) ;
			if ((errcode=k_execute(ps, CntofStr, CntofString, (char)0))!=0) // execute commands
				MyError2(errcode, parm->p[3].val.ev_handle);
			_HUnLock(parm->p[3].val.ev_handle);
			
			if (parm->pCount == 5)	{  
				NullTerminate(&parm->p[4].val);     // Convert to ASCIIZ       
				_HLock(parm->p[4].val.ev_handle);   // Lock string passed value            	         
				if ((errcode=_Evaluate(&result, (char FAR *) _HandToPtr(parm->p[4].val.ev_handle)))!=0)
					MyError2(errcode, parm->p[4].val.ev_handle);
				else
					_RetVal(&result);
				_HUnLock(parm->p[4].val.ev_handle);
				return;
			}   
		}  
		_RetNULL(VERSION)  // or .NULL. for VFP                        
			return;
}
//--------------- End ifor, iwhile, iexeccase,  iexecif, execute ----------------------------


//--------------- Begin getallwords, wordtran, getnumword, getoccursword, getatword, getatword ----------------------------
//--------------------------------------------------------------------------
void FAR getallwords(ParamBlk FAR *parm, char flag ) {
	Value v;
	char bkstr[MAXBREAK];
	MHANDLE t;
	unsigned long EndOfWord = 0, BegOfWord = 0, maxlengthword = 0, wordcount = 0;
	char FAR *varName;
	Locator loc;
	int errcode ;
	NTI nti;
	char FAR *p;
	char exit = 0;
#if  VERSION == VFP 
	unsigned long arrWords3[MAXARRSIZE];
	unsigned int arrWords4[MAXARRSIZE];
#else
	unsigned int arrWords3[MAXARRSIZE];
	char arrWords4[MAXARRSIZE];
#endif
	
	t = gethandle(parm, 1);
	if (t == 0) 
		_UserError("Data type mismatch\n");
	
	_HLock(t);
	
	if (parm->pCount > 2) {
		v = parm->p[2].val;
		if (!flag && v.ev_length == 0)
			_StrCpy(bkstr, " ");
		else {
			_MemMove(bkstr,_HandToPtr(v.ev_handle),min(MAXBREAK,v.ev_length));
			bkstr[min(MAXBREAK,v.ev_length)] = '\0';
		}
	}
	else
		_StrCpy(bkstr, (flag) ? DFTBREAK : " ");
	
	p = (char FAR *)_HandToPtr(t);
	
	while (TRUE) {
		if  (EndOfWord > BegOfWord) { 
			arrWords3[wordcount] = BegOfWord;   // begin of previous word
			arrWords4[wordcount] = EndOfWord-BegOfWord; // length of previous word
			if (maxlengthword < arrWords4[wordcount])
				maxlengthword = arrWords4[wordcount];
			wordcount++;
			if (wordcount > MAXARRSIZE) {
				_UserError(ERRMSGMAXARRSIZE);
			}
		}
		if (exit)
			break;
		if (flag) {
			for (; *p && strchr(bkstr,*p) != NULL ; p++ ) ;
			BegOfWord = (unsigned long)(p - (char FAR *)_HandToPtr(t)) ;
			if (*p)  
				p++;  // Skip over the first character in the word. We know it can not be a break character.
			for (; *p && strchr(bkstr,*p) == NULL ; p++ ) ;
			EndOfWord  = (unsigned long)(p - (char FAR *)_HandToPtr(t)) ;
			if (!*p) 
				exit = 1;
			else
				p++;  // Skip over the first break character. We know it can not be a word character.
		}
		else {
			BegOfWord = EndOfWord;
			for (p = (char FAR *)_HandToPtr(t) + BegOfWord; _MemCmp(p, bkstr, _StrLen(bkstr)) == 0 ; p+= _StrLen(bkstr), BegOfWord += _StrLen(bkstr) ) ;
			p = strstr(p, bkstr);
			if (p == NULL) {
				EndOfWord = _StrLen((char FAR *)_HandToPtr(t));
				exit = 1;
			} 
			else 
				EndOfWord = (unsigned long)(p - (char FAR *)_HandToPtr(t)) ;
		}
	} 
	NullTerminate(&parm->p[0].val);     // Convert to ASCIIZ
	_HLock(parm->p[0].val.ev_handle);
	varName = (char FAR *) _HandToPtr(parm->p[0].val.ev_handle);
	
	//    ,    
	if ((nti = _NameTableIndex(varName)) > -1) 
		if (_FindVar(nti, -1, &loc)) 
			if ((errcode =_Release(nti)) < 0)
				_Error(-errcode);
			
			if (wordcount) {
				loc.l_subs = 2;
				loc.l_sub1 = (USHORT)wordcount;
				loc.l_sub2 = 4;
				// we create an array 
				//     8.0 ,     16250  ,     65000 ,   4 .
				//  LCK  9.0     65000  .    ,             Too many variables
				if ((nti = _NewVar(varName, &loc, NV_PUBLIC)) < 0)  // or NV_PRIVATE
					_Error(-nti);  		// _NewVar() returns negative Visual FoxPro error number
				
				if (_FindVar(nti, -1, &loc)) {
					if ((v.ev_handle = _AllocHand(maxlengthword)) == 0)
						_Error(182); // "Insufficient memory"
					
					_HLock(v.ev_handle);
					p = (char FAR *) _HandToPtr(t);
					for ( loc.l_sub1 = 1; loc.l_sub1 <= wordcount; loc.l_sub1++) {
						for ( loc.l_sub2 = 1; loc.l_sub2 <= 4; loc.l_sub2++) {
							v.ev_type = 'I';
							switch (loc.l_sub2) {
							case 1 :
								v.ev_long = loc.l_sub1;
								break;
							case 2 :
								v.ev_type = 'C';
								v.ev_length = arrWords4[loc.l_sub1-1];
								_MemMove(_HandToPtr(v.ev_handle), p+arrWords3[loc.l_sub1-1], v.ev_length);
								break;
							case 3 :
								v.ev_long = arrWords3[loc.l_sub1-1]+1;
								break;
							case 4 :
								v.ev_long = arrWords4[loc.l_sub1-1];
								break;
							default:
								break;
							}
							_Store(&loc, &v);
						}
					} 
					_HUnLock(v.ev_handle);
					_FreeHand(v.ev_handle);
				}
			}
			_HUnLock(parm->p[0].val.ev_handle);
			
            _HUnLock(t);
			if (parm->p[1].val.ev_type != 'C')  // we must not free handles passed to them in their ParamBlk !
				_FreeHand(t);  /* Free MHANDLEs we allocate, but not handles passed in ParamBlk. */
			
			_RetInt(maxlengthword, 10);
}


void FAR getallwords1(ParamBlk FAR *parm) {
	getallwords(parm, TRUE) ;
}

void FAR getallwords2(ParamBlk FAR *parm) {
	getallwords(parm, FALSE) ;
}


// ---------- Begin wordtran -------------------------------
//    wordtran, wordtranex, strtranex 
//  'U'       
//  'L'       
//  'P'        
//  '\0'       
//  are the letters for isalpha but are not the letters for FoxPro
//   are the letters for FoxPro but are not the letters for isalpha
// this function does not work correctly for ''
char FAR fwhatiscase(char FAR *Str, long lenStr) {
	long  i, j = 0;
	char flags = 0;
	
	flags |= 0x1  ;
	for ( i = 0; i < lenStr; i++) {
		if ( toupper(Str[i]) != tolower(Str[i]) ) {  // if this character is letter
			j = i ;
			flags = 0;
			if (  Str[i] == (char)toupper(Str[i])) 
				flags |= 0x2  ; // do not check lower case
			if (  Str[i] == (char)tolower(Str[i])) 
				flags |= 0x4  ; // do not check upper case
			if ( i > 0 || (i == 0  &&  flags & 0x4)) 
				flags |= 0x8  ; // do not check proper case
			break;
        }
    }
	
	if (flags & 0x1)
		return '\0' ;  // string has no letters
	
	if (!(flags & 0x4)) {	// do not check upper case
		flags |= 0x1;
		for ( i = j; i < lenStr; i++) {
			if ( toupper(Str[i]) != tolower(Str[i])  // if this character is letter
				&& (  Str[i] != (char)toupper(Str[i])) ) {  
				flags &= 0xFE ;
				break;
			}
        }
		if (flags & 0x1)
			return 'U' ;
	}	
	
	if (!(flags & 0x2)) {  // do not check lower case
		flags |= 0x1;
		for ( i = j; i < lenStr; i++) {
			if ( toupper(Str[i]) != tolower(Str[i])  // if this character is letter
				&& (  Str[i] != (char)tolower(Str[i])) ) {  
				flags &= 0xFE ;
				break;
			}
		}
		if (flags & 0x1)
			return 'L' ;
	}
	
	if (!(flags & 0x8)) {  // do not check proper case
		flags |= 0x1;
		if ( toupper(Str[0]) != tolower(Str[0])  // if this character is letter
			&& (  (Str[0] == (char)toupper(Str[0])) ) ) {  
			for ( i = 1; i < lenStr; i++) {
				if ( toupper(Str[i]) != tolower(Str[i]) ) {  // if this character is letter
					if ( Str[i] != (char)tolower(Str[i]))   {  
						flags &= 0xFE ;
						break;
					}
				}
			}
			if (flags & 0x1)  
				return 'P' ;
		}
	}	
	
	for ( i = j; i < lenStr; i++) {
		if ( toupper(Str[i]) != tolower(Str[i]) ) { // if this character is letter
			if (  Str[i] == (char)tolower(Str[i]) )  
				return 'L' ;
			else  
				return '\0' ;
		}
	}
	
	return '\0' ;
}


/* wordtran()   ,    ,             
wordtran (cSearched, cWordSought , [cWordReplacement] [, lcDelimiters] [, nStartOccurrence] [, nNumberOfOccurrences] [, nFlags])
   

 cSearched   ,    WORDTRAN()      cWordSought.
 cWordSought ,       cSearched.
 cWordReplacement ,     cWordSought   cSearched.
   cWordReplacement  ,    cWordSought      ,   . 
   lcDelimiters  ,   256  -   ,
     ,         cSearched.
	    ,  ,     . 
	wordtran()       lcDelimiters   ,     lcDelimiters    . 
	: wordtran()   ,     ,  ,     .
	    lcDelimiters,    ,  ,     .   ,    ,    .      ,   ,  , ,     GETWORDNUM(), GETWORDCOUNT() .
	   
		 nStartOccurrence ,      cWordSought   .
		 ,   nStartOccurrence  4,        cWordSought   cSearched,        cWordSought    .          cWordSought,     nStartOccurrence   . 
		 nNumberOfOccurrences ,      cWordSought    cSearched   .   nNumberOfOccurrences   ,     cWordSought    cSearched,    nStartOccurrence  . 
		 nFlags          :
		 -----------------------------------------------------------------------------------------
		 nFlags 
		 0  ( )  -1    ,       cWordReplacement.
		 1     ,       cWordReplacement.
		 2    ,       cWordReplacement          .     cWordReplacement    ,      ,      (       ,    ).
		 3     ,       cWordReplacement          .     cWordReplacement    ,      ,      (       ,    ).
		 -----------------------------------------------------------------------------------------
		 :
		       cWordSought    cSearched         cSearched.
			     nStartOccurrence -      nNumberOfOccurrences  .   cWordReplacement , cWordSought     ().     nStartOccurrence,             .  nNumberOfOccurrences    .
			  -1    , , ,      nFlags,      .
			  */
			  void FAR wordtran(ParamBlk FAR *parm) {
				  Value v;
				  MHANDLE t;
				  MHANDLE t_tran;
				  long EndOfWord = 0, BegOfWord = 0;
				  long wordcount = 0, wordtrancount = 0;
				  long nStartOccurrence = 1, nNumberOfOccurrences = -1 ;
				  long lenString, lenWordReplacement = 0, lenWordSought, i, j;
				  char whatiscase = '\0' ;
				  char FAR *p;
				  char exit = 0;
				  int  nFlags = 0, lenofword = 0;
				  char bkstr[MAXBREAK]=DFTBREAK;
#if  VERSION == VFP 
				  unsigned long arrWords3[MAXCNTWORDS];
#else
				  unsigned int arrWords3[MAXCNTWORDS];
#endif
				  char arrWords4[MAXCNTWORDS];
				  
				  t = gethandle(parm, 0);
				  if (t == 0) 
					  _UserError("Data type mismatch in function WORDTRAN\n");
				  
				  _HLock(t);
				  
				  lenString = _StrLen((char FAR *)_HandToPtr(t)) ;
				  lenWordSought = parm->p[1].val.ev_length ;
				  
				  
				  NullTerminate(&parm->p[1].val);    // Convert to ASCIIZ
				  _HLock(parm->p[1].val.ev_handle);   // Lock string passed value
				  
				  
				  if (parm->pCount >= 3) {
					  NullTerminate(&parm->p[2].val);    // Convert to ASCIIZ
					  _HLock(parm->p[2].val.ev_handle);   // Lock string passed value
					  lenWordReplacement = parm->p[2].val.ev_length ;
				  }
				  
				  if (parm->pCount >= 4) {
					  if (parm->p[3].val.ev_type == 'C') {
						  v = parm->p[3].val;
						  _MemMove(bkstr,_HandToPtr(v.ev_handle),min(MAXBREAK,v.ev_length));
						  bkstr[min(MAXBREAK,v.ev_length)] = '\0';
					  }
					  else {
						  if (parm->p[3].val.ev_type != 'I' && parm->p[3].val.ev_type != 'N' ) {
							  _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
						  }
						  else {
							  if ( ((parm->p[3].val.ev_type == 'I') ? parm->p[3].val.ev_long : (long) parm->p[3].val.ev_real ) != -1) 
								  _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
						  }
					  }
				  }
				  
				  if (parm->pCount >= 5) 
					  nStartOccurrence = (parm->p[4].val.ev_type == 'I') ? parm->p[4].val.ev_long : (long) parm->p[4].val.ev_real  ;
				  
				  if (nStartOccurrence < -1  || nStartOccurrence == 0 )
					  _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
				  
				  if (nStartOccurrence == -1)
					  nStartOccurrence = 1 ;
				  
				  if (parm->pCount >= 6) 
					  nNumberOfOccurrences = (parm->p[5].val.ev_type == 'I') ? parm->p[5].val.ev_long : (long) parm->p[5].val.ev_real  ;
				  
				  
				  if (nNumberOfOccurrences  < -1  || nNumberOfOccurrences  == 0 )
					  _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
				  
				  //  nFlags  Specifies Case-sensitive search criteria To Apply To This Function. Valid Values are 0 (the Default) And 1.
				  //  0, 2 Case-sensitive search
				  //  1, 3 Case insensitive search
				  if (parm->pCount == 7)  
					  nFlags = (parm->p[6].val.ev_type == 'I') ? parm->p[6].val.ev_long : (long) parm->p[6].val.ev_real  ;
				  
				  if (nFlags < 0 || nFlags > 3)
					  _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
				  
				  if (nFlags == 2 && lenWordReplacement > 0) {
					  whatiscase = fwhatiscase((char FAR *)_HandToPtr(parm->p[1].val.ev_handle), lenWordSought) ;
					  
					  switch(whatiscase)	{
					  case 'U':
						  _strupr((char FAR *)_HandToPtr(parm->p[2].val.ev_handle)) ; 
						  break ;
					  case 'L':
						  _strlwr((char FAR *)_HandToPtr(parm->p[2].val.ev_handle)) ; 
						  break ;
					  case 'P':
						  ((char FAR *) _HandToPtr(parm->p[2].val.ev_handle))[0] = toupper( *(char FAR *)_HandToPtr(parm->p[2].val.ev_handle) ) ;
						  _strlwr((char FAR *)_HandToPtr(parm->p[2].val.ev_handle)+1) ; 
						  break ;
					  default:
						  break ;
					  }
				  }
				  
				  
				  if (nFlags & 0x1)   //  1, 3 Case insensitive search
					  memcompar = memicmp ;  //       
				  else 
					  memcompar = memcmp ;   //       
				  
				  
				  
				  p = (char FAR *)_HandToPtr(t);
				  
				  while (TRUE) {
					  if  (EndOfWord > BegOfWord) { // BegOfWord begin of previous word
						  if ( lenWordSought  == (EndOfWord-BegOfWord)) { // length of previous word
							  if (memcompar((void FAR *)((char FAR *)_HandToPtr(t)+BegOfWord), _HandToPtr(parm->p[1].val.ev_handle), (unsigned int) lenWordSought ) == 0)  {
								  wordcount++;
								  if ( wordcount >= nStartOccurrence && ( nNumberOfOccurrences == -1 || wordcount < (nStartOccurrence+nNumberOfOccurrences))) {
									  arrWords3[wordtrancount] = BegOfWord;   // begin of word
									  arrWords4[wordtrancount] = (nFlags < 3)? '\0': fwhatiscase((char FAR *)_HandToPtr(t)+BegOfWord, lenWordSought) ;
									  wordtrancount ++ ; 
								  } 
							  }
						  } 
					  }
					  if (wordtrancount > MAXCNTWORDS) {
						  _UserError(ERRMSGMAXCNTWORDS);
					  }
					  if (exit)
						  break;
					  for (; *p && strchr(bkstr,*p) != NULL ; p++ ) ;
					  BegOfWord = (unsigned long)(p - (char FAR *)_HandToPtr(t)) ;
					  if (*p)  
						  p++;  // Skip over the first character in the word. We know it can not be a break character.
					  for (; *p && strchr(bkstr,*p) == NULL ; p++ ) ;
					  EndOfWord  = (unsigned long)(p - (char FAR *)_HandToPtr(t)) ;
					  if (!*p) 
						  exit = 1;
					  else
						  p++;  // Skip over the first break character. We know it can not be a word character.
				  } 
				  
				  
				  if (wordtrancount) {
					  if ( (t_tran = _AllocHand(lenString + 1 + ( lenWordReplacement  - lenWordSought ) * wordtrancount) ) == 0) {
						  _Error(182);	// insufficient memory
					  }
					  _HLock(t_tran);		
					  ((char FAR *) _HandToPtr(t_tran))[lenString + 1 + ( lenWordReplacement  - lenWordSought ) * wordtrancount] = '\0';
				  }
				  for ( i = 0 ; i < wordtrancount ; i++) {
					  if (i) {
						  _MemMove((void FAR *)((char FAR *)_HandToPtr(t_tran)+j),(void FAR *)((char FAR *) _HandToPtr(t)+arrWords3[i-1]+lenWordSought), (unsigned int) (arrWords3[i]  - (arrWords3[i-1]+lenWordSought)) ) ;			
						  j += (arrWords3[i] - (arrWords3[i-1]+lenWordSought));
					  }
					  else {
						  j =  arrWords3[i] ;
						  _MemMove(_HandToPtr(t_tran),_HandToPtr(t), (unsigned int) (j)) ;
					  }
					  
					  if (lenWordReplacement > 0) {  		// copy cWordReplacement
						  _MemMove((void FAR *)((char FAR *)_HandToPtr(t_tran)+j), _HandToPtr(parm->p[2].val.ev_handle), (unsigned int) lenWordReplacement) ;
						  
						  if (nFlags == 3 && arrWords4[i] != '\0') {
							  ((char FAR *) _HandToPtr(t_tran))[j + lenWordReplacement] = '\0'; //  for string functions
							  switch(arrWords4[i])	{
							  case 'U':
								  _strupr((char FAR *)_HandToPtr(t_tran)+j) ; 
								  break ;
							  case 'L':
								  _strlwr((char FAR *)_HandToPtr(t_tran)+j) ; 
								  break ;
							  case 'P':
								  ((char FAR *) _HandToPtr(t_tran))[j] = toupper( *((char FAR *)_HandToPtr(t_tran)+j)) ;
								  _strlwr((char FAR *)_HandToPtr(t_tran)+j+1) ; 
								  break ;
							  default:
								  break ;
							  }
						  }
					  }
					  j += lenWordReplacement ;
				  }
				  
				  
				  //   
				  if (wordtrancount)
					  _MemMove((void FAR *)((char FAR *)_HandToPtr(t_tran)+j),(void FAR *)((char FAR *) _HandToPtr(t)+arrWords3[wordtrancount-1]+lenWordSought), (unsigned int) (lenString  - (arrWords3[wordtrancount-1]+lenWordSought - 1)) ) ;			
				  
				  if (lenWordReplacement > 0)
					  _HUnLock(parm->p[2].val.ev_handle);	
				  
				  _HUnLock(parm->p[1].val.ev_handle);
				  
				  
				  if (wordtrancount) {
					  _RetChar((char FAR *)_HandToPtr(t_tran)) ;
					  _HUnLock(t_tran);	
					  _FreeHand(t_tran);
				  }
				  else 
					  _RetChar((char FAR *)_HandToPtr(t)) ;
				  
				  
				  _HUnLock(t);
				  if (parm->p[0].val.ev_type != 'C')  // we must not free handles passed to them in their ParamBlk !
					  _FreeHand(t);	 /* Free MHANDLEs we allocate, but not handles passed in ParamBlk. */
}
// ---------- End wordtran -------------------------------



#define FGETOCCURSWORD  (char)1
#define FGETNUMWORD     (char)2
#define FGETATWORD      (char)3
#define FGETRATWORD     (char)4


void FAR fgetword(ParamBlk FAR *parm, char what) {
    Value v;
    MHANDLE t;
    unsigned long EndOfWord = 0, BegOfWord = 0, wordcount = 0;
    char FAR *p;
    char exit = 0;
    int nOccurrence = 1, lnOccurrence = 0, nFlags = 0, lenofword = 0;
    char bkstr[MAXBREAK]=DFTBREAK;
    
    t = gethandle(parm, 0);
    if (t == 0) 
        _UserError("Data type mismatch\n");
    
    _HLock(t);
    
    NullTerminate(&parm->p[1].val);    // Convert to ASCIIZ
    _HLock(parm->p[1].val.ev_handle);   // Lock string passed value
    
    if (parm->pCount > 2) {
        if (parm->p[2].val.ev_type == 'C') {
            v = parm->p[2].val;
            _MemMove(bkstr,_HandToPtr(v.ev_handle),min(MAXBREAK,v.ev_length));
            bkstr[min(MAXBREAK,v.ev_length)] = '\0';
        }
		else {
			if (parm->p[2].val.ev_type != 'I' && parm->p[2].val.ev_type != 'N' ) {
				_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
			}
			else {
				if ( ((parm->p[2].val.ev_type == 'I') ? parm->p[2].val.ev_long : (long) parm->p[2].val.ev_real ) != -1) 
					_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
			}
		}
		
    }
    
    
	if (what != FGETOCCURSWORD) {
		// nOccurrence Specifies which occurrence, first, second, third, and so on, of cWord to search for in cString.
		// By default the function searches for the first occurrence of cWord (nOccurrence = 1).
		if (parm->pCount >= 4)  
			nOccurrence = (parm->p[3].val.ev_type == 'I') ? parm->p[3].val.ev_long : (long) parm->p[3].val.ev_real  ;
		if (nOccurrence < 1)
			nOccurrence = 1;
    }
	
    //  nFlags  Specifies Case-sensitive search criteria To Apply To This Function. Valid Values are 0 (the Default) And 1.
    //  0 Case-sensitive search
    //  1 Case insensitive search
    if (what == FGETOCCURSWORD) {
		if (parm->pCount == 4)  
			nFlags = (parm->p[3].val.ev_type == 'I') ? parm->p[3].val.ev_long : (long) parm->p[3].val.ev_real  ;
	}
    else {
		if (parm->pCount == 5)  
			nFlags = (parm->p[4].val.ev_type == 'I') ? parm->p[4].val.ev_long : (long) parm->p[4].val.ev_real  ;
	}
	
	
    if (nFlags < 0 || nFlags > 1)
       	_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
    
	if (nFlags)  //  Case insensitive search
		memcompar = memicmp ;  //       
	else 
		memcompar = memcmp ;   //       
	
	
	if (what == FGETRATWORD) {
		p = (char FAR *)_HandToPtr(t) + parm->p[0].val.ev_length  - 1;
		EndOfWord =  BegOfWord = parm->p[0].val.ev_length - 1 ;
	}
	else {
		p = (char FAR *)_HandToPtr(t) ;
    }
	
	
    while (TRUE) {
        if  (EndOfWord > BegOfWord) {  // BegOfWord begin of previous word
            if ( parm->p[1].val.ev_length  == (EndOfWord-BegOfWord)) { // length of previous word
                if  ( memcompar((void FAR *)((char FAR *)_HandToPtr(t)+BegOfWord), _HandToPtr(parm->p[1].val.ev_handle), parm->p[1].val.ev_length ) == 0 ) {  
                    lnOccurrence ++;
					if (what != FGETOCCURSWORD)
						if (lnOccurrence == nOccurrence) 
							exit = 1;
                }
            } 
			wordcount ++ ;
        }
        if (exit)
            break;
		
		if (what == FGETRATWORD) {  //    ,   n-          ,     getatword()   
			for (; *p && strchr(bkstr,*p) != NULL ; p-- ) ;
			EndOfWord = (unsigned long)(p - (char FAR *)_HandToPtr(t)) + 1 ;
			if (p >=(char FAR *)_HandToPtr(t)) 
				p--;  // Skip over the first character in the word. We know it can not be a break character.
			for (; *p && strchr(bkstr,*p) == NULL ; p-- ) ;
			BegOfWord = (unsigned long)(p - (char FAR *)_HandToPtr(t)) + 1 ;
			if (p < (char FAR *)_HandToPtr(t)) 
				exit = 1;
			else
				p--;  // Skip over the first break character. We know it can not be a word character.
		}
		else {
			for (; *p && strchr(bkstr,*p) != NULL ; p++ ) ;
			BegOfWord = (unsigned long)(p - (char FAR *)_HandToPtr(t)) ;
			if (*p)  
				p++;  // Skip over the first character in the word. We know it can not be a break character.
			for (; *p && strchr(bkstr,*p) == NULL ; p++ ) ;
			EndOfWord  = (unsigned long)(p - (char FAR *)_HandToPtr(t)) ;
			if (!*p) 
				exit = 1;
			else
				p++;  // Skip over the first break character. We know it can not be a word character.
		}
		
    } 
	
    _HUnLock(parm->p[1].val.ev_handle);
    _HUnLock(t);
	
	if (parm->p[0].val.ev_type != 'C')  // we must not free handles passed to them in their ParamBlk !
		_FreeHand(t); /* Free MHANDLEs we allocate, but not handles passed in ParamBlk. */
    
	if (what == FGETOCCURSWORD)
		_RetInt(lnOccurrence, 10);
    else
		_RetInt(lnOccurrence == nOccurrence ? (what == FGETNUMWORD ? wordcount : ++BegOfWord) :0, 10);
}


void FAR getoccursword(ParamBlk FAR *parm) {	fgetword(parm, FGETOCCURSWORD);}  //       
void FAR getnumword(ParamBlk FAR *parm)    {	fgetword(parm, FGETNUMWORD)   ;}  //        
void FAR getatword(ParamBlk FAR *parm)     {	fgetword(parm, FGETATWORD)    ;}  //    ,   n-          
void FAR getratword(ParamBlk FAR *parm)    {	fgetword(parm, FGETRATWORD)   ;}  //    ,   n-          ,     getatword()   

//--------------- End getallwords, wordtran, getnumword, getoccursword, getatword, getatword  ----------------------------


//--------------- Begin  strtranex, wordtranex, strfilterex  ----------------------------
#define FSTRTRANEX     0  // do not change this value !
#define FWORDTRANEX    1  // do not change this value !
#define FSTRFILTEREX  -1  // do not change this value !

#define MAXQNTDIFFWORDS 63
#define SEARCHEDSUBSTRINGWASFOUND 128

#if  VERSION == VFP 
#define _CDECL  __cdecl
#else
#define _CDECL 
#endif

#if  VERSION != VFP 
#define memcmp  _fmemcmp 
#define memicmp _fmemicmp
#endif


#define TYPE_CASE_AND_NUMBER unsigned char

int ( _CDECL *memcompar ) (const void *s1, const void *s2, size_t n);

#if  VERSION == VFP 
typedef struct  {
	unsigned long position; // The character position in cString where the word starts 
	TYPE_CASE_AND_NUMBER case_and_number;  // The case and number of the word 
} foundSubSrt_or_Words;

char * ( __cdecl * strSearch ) (const char *string, const char * strSearch );

#else

typedef struct {
	unsigned int position; // The character position in cString where the word starts 
	TYPE_CASE_AND_NUMBER case_and_number;  // The case and number of the word 
} foundSubSrt_or_Words ;

char FAR * (*strSearch ) (const char FAR *string, const char FAR * strSearch );
#define strstr _fstrstr
#endif



// http://www.gipsysoft.com/code/code/stristr.cpp
/* Find first occurrence of specified string in another string without regard to case */
char FAR * _CDECL stristr(const char FAR * string, const char FAR * strSrch  )  {
	const int len = _StrLen( (char FAR *)strSrch);
	while( *string ) {
		if ( !strnicmp(string, strSrch, len) )
			break;
		string++;
	}
	if ( !( *string ) )
		string = NULL;
	
	return (char FAR *) string;
}


/*  http://www.geocities.com/uthcode2/C.html
get n bits from the position p 
getbits:  n ,   -  
Program implements getbits(x,p,n).
* x is a unsigned integer. For eg. 8, represented by 0000 1000
* p is the position we wish to select.For eg, 3, which gives the location of bit value 1.
* n is the number of bits, we wish to select. Lets select 1.
* getbits(8,3,1) will return right shifted value the number x (8) from the position p(3) till we get n(1) bits.
So, 0000 1000, should be shifted and will become 0000 0001
If n were 2,getbits(8,3,2), then 0000 1000 should be shifted as 0000 0010  
*/
TYPE_CASE_AND_NUMBER getbits(TYPE_CASE_AND_NUMBER x, int p, int n) {
	return (x >> (p+1-n)) & ~(~0 << n);
}


/* this function returns x with the n bits that begin at positionp set to the rightmost n bits of y,
leaving the other bits unchanged.
  ,    ,   - ,    
     (   ). 
  function implements setbits(x,p,y,n) - Return x, which is modified in such a way that, at position p in x, there are n bits modified (how?) by replacing the rightmost n bits of y (is that all, no) begining at p (in y as well).
  x - 0000 1100
  p - 3
  n - 2
  y - 0011 0001
  So, show bits should return x = 0000 0100
*/
TYPE_CASE_AND_NUMBER setbits(TYPE_CASE_AND_NUMBER x, int p,int n, TYPE_CASE_AND_NUMBER y) {
	return x & ~(~(~0 << n) << (p+1-n)) | ( y & ~(~0<<n)) << (p+1-n);
}


//      foundSubSrt_or_Words
int _CDECL icompare_funct (const void * a, const void * b) {
	long r = ( (long)((foundSubSrt_or_Words *)a)->position) -  (long)(((foundSubSrt_or_Words *)b)->position) ;
	if  ( r > 0 )
		return 1 ;   
	else
		return ((r < 0 )?-1:0) ; 
}


char FAR * wordSearch(char FAR * string,  char FAR * WordSrch, char FAR * bkstr, int tnFlags) {
    unsigned long EndOfWord = 0, BegOfWord = 0, position = 0;
    char FAR *p = string ;
    char exit = 0;
    const int nLenWord = _StrLen(WordSrch);
	
    //  tnFlags  Specifies Case-sensitive search criteria To Apply To This Function. 
	//  Valid Values are 0 (the Default), 1, 2, 3
    //  0, 2, 4 Case-sensitive search
    //  1, 3 Case insensitive search
	if (tnFlags & 0x1)   //  Case insensitive search
		memcompar = memicmp ;
	else 
		memcompar = memcmp ;
	
	
    while (TRUE) {
        if  (EndOfWord > BegOfWord) {  // BegOfWord begin of previous word
            if ( nLenWord == (const int) (EndOfWord-BegOfWord)) { // length of previous word
                if  ( memcompar((void FAR *)(string +BegOfWord), (void FAR *)WordSrch, nLenWord ) == 0 )   
					return (string + BegOfWord);
            } 
        }
        if (exit)
            break;
		
		for (; *p && strchr(bkstr,*p) != NULL ; p++ ) ;
		BegOfWord = (unsigned long)(p - string) ;
		if (*p)  
			p++;  // Skip over the first character in the word. We know it can not be a break character.
		for (; *p && strchr(bkstr,*p) == NULL ; p++ ) ;
		EndOfWord  = (unsigned long)(p - string) ;
		if (!*p) 
			exit = 1;
		else
			p++;  // Skip over the first break character. We know it can not be a word character.
    } 
    return NULL;
}


//  
// 	AuxiliarySearchFunction(&ArrayFoundSubStr_or_Words[nLastRowForCycle], nHowmanyhavebeenfound, (long)(pcSearched-(char FAR *)_HandToPtr(t)), i, &pcSearched, &aVal, nStartOccurrence, nNumberOfOccurrences, nFlags) ;
long AuxiliarySearchFunction(foundSubSrt_or_Words * pArrayFoundSubStr_or_Words,
							 long * tnHowmanyhavebeenfound,
							 long tnBegOfSearchedString,
							 long tnI,
							 char FAR * pcStrSearched,
							 Value FAR * taVal,
							 long tnStartOccurrence,
							 long tnNombreOccurrences,
							 int tnFlags,
							 char FAR * bkstr) {
	
    // pcStrSearched -       
	// taVal -    Value  
	// tnBegOfSearchedString -     pcStrSearched    
	// pArrayFoundSubStr_or_Words	 ,        
	// ( ,           )
	// tnI  ,     ,
	//     case_and_number  foundSubSrt_or_Words,
	//      
    // tnHowmanyhavebeenfound -     ,
	// tnStartOccurrence      
    // tnNombreOccurrences    
    // tnFlags -  
	// bkstr for word search 
	long i = 0, j = 0, nlf = 0;
	char FAR * p;
	char FAR * pcStrSought;  // pcStrSought -  
	char whatiscase = '\0' ;
	char IfWordTran = (char) (bkstr != NULL) ?1:0;
	
	if (tnNombreOccurrences > 0) {
		if  ( tnStartOccurrence  +  tnNombreOccurrences < *tnHowmanyhavebeenfound )
			return 0;
    }
	
	pcStrSought = (char FAR *)_HandToPtr(taVal->ev_handle);
	
	if (!IfWordTran) {
		if (tnFlags & 0x1) 
			strSearch = stristr ;  //  1, 3    Case insensitive search
		else 
			strSearch = strstr ;   //  0, 2, 4 Case sensitive search
	}
	
	do {
		if (p = (IfWordTran) ?  wordSearch(pcStrSearched+j, pcStrSought, bkstr, tnFlags) : strSearch(pcStrSearched+j, pcStrSought) ) {
			nlf++ ;
			j = (long)(p - pcStrSearched);
			if ( nlf+ *tnHowmanyhavebeenfound >= tnStartOccurrence && (tnNombreOccurrences == -1 || (nlf+ *tnHowmanyhavebeenfound < tnStartOccurrence + tnNombreOccurrences) ) ) {
				pArrayFoundSubStr_or_Words[i].position =  j + tnBegOfSearchedString ;
				pArrayFoundSubStr_or_Words[i].case_and_number =  (TYPE_CASE_AND_NUMBER)tnI ;
				//     -   ,  nFlags  3	
				// tnFlags == 4 if (parm->p[2].val.ev_type == 'C') && tnFlags == 2
				if (tnFlags == 3 || tnFlags == 4) {
					whatiscase = fwhatiscase(p, _StrLen(pcStrSought)) ;
					// returns 'U' if the string has a UPPER case
					// returns 'L' if the string has a lower case
					// returns 'P' if the string has a Proper case
					// else this function returns '\0' 
					switch(whatiscase)	{
					case 'U':
						whatiscase = (char)1 ; 
						break ;
					case 'L':
						whatiscase = (char)2 ;
						break ;
					case 'P':
						whatiscase = (char)3 ;
						break ;
					default:
						break ;
					}
                    
					if (whatiscase)  
						pArrayFoundSubStr_or_Words[i].case_and_number = setbits(pArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 1, 2, (TYPE_CASE_AND_NUMBER)whatiscase) ; 
				}
				*p ='\0';  //             
				i++;
			}
			else {
				if 	(tnNombreOccurrences != -1 && nlf+*tnHowmanyhavebeenfound >= tnStartOccurrence + tnNombreOccurrences )
					break;  
			}
			j += taVal->ev_length + ((IfWordTran) ? 1: 0) ; 
		}
		
	} while( p ) ;
	
	*tnHowmanyhavebeenfound += nlf;
	return  i;
}



void FAR ftranex(ParamBlk FAR *parm, int iWhatFunction) {
	Value v;
	Value  aVal;
	MHANDLE t;
	MHANDLE t_tran;
	long i, j, k;
	int errcode	 = 0;
	long nLenString, nLenStrSought, nLenStrReplacement, nLenReturnedString = 0;
	long nStartOccurrence, nNumberOfOccurrences, nStartOccurrenceDef = 1, nNumberOfOccurrencesDef = -1;
	int  nFlagsDef = 0, nFlags = 0;
	long nRowsSearched = 0, nLastRowForCycle = 0; //         
	long nHowmanyhavebeenfound = 0;              //       
	long nHowmanyhavebeenfoundForReplace = 0;    //     ,    
	USHORT nNumberOfRowSubstrForReplace  ;   
	char whatiscase = '\0' ;
    char NeedReleaseMem = (char)0;	
	char FAR * pcSearched; 
	char bkstr[MAXBREAK]=DFTBREAK;
	foundSubSrt_or_Words ArrayFoundSubStr_or_Words[MAXCNTWORDS];
	
	long ArrayLengthOfFoundSubStr_or_Words[MAXQNTDIFFWORDS];   //    
	//  long ArrayLengthOfReplacedSubStr_or_Words[]     ,
	//        .
	//       ,      SEARCHEDSUBSTRINGWASFOUND.
	//         -.
	//    ,      -, 
	//          
	long ArrayLengthOfReplacedSubStr_or_Words[MAXQNTDIFFWORDS]; 
	
	
	// ------- check the parameters ------- 
	for ( j = 1; j < (6 + iWhatFunction); j++ ) {
								if (parm->pCount > j) {
									if ( iWhatFunction != FWORDTRANEX || ( iWhatFunction == FWORDTRANEX && j!= 3)) {
										if (parm->p[j].val.ev_type == 'R') {  // This parameter was passed by reference.
											if ( (i=_ALen(parm->p[j].loc.l_NTI, AL_SUBSCRIPT1))==-1) {
												_Error(232) ;  // is not an array  !
											}
											parm->p[j].loc.l_subs = _ALen(parm->p[j].loc.l_NTI, AL_SUBSCRIPT2)>0?2:1 ;
											
											if (parm->p[j].loc.l_subs == 2)
												parm->p[j].loc.l_sub2= (short)1 ;  // we use always the first column of array
											else 
												parm->p[j].loc.l_sub2=(short)0 ;   // the onedimensional array
										}
										else {
											if (parm->p[j].val.ev_type == 'C'  && j < (3+ iWhatFunction)) {
												if ( j == 1) {
													nRowsSearched = 1 ;
                                                }
                                            }
											else {
												if (parm->p[j].val.ev_type == 'I'  || parm->p[j].val.ev_type == 'N') {
													;
												}
												else
													_Error(901) ; // Function argument value, type, or count is invalid (Error 11)	
                                            }  
										}
									}
								}  
	}
	
	
    if (iWhatFunction == FWORDTRANEX) {
		if (parm->pCount >= 4) {
			if (parm->p[3].val.ev_type == 'C') {
				v = parm->p[3].val;
				_MemMove(bkstr,_HandToPtr(v.ev_handle),min(MAXBREAK,v.ev_length));
				bkstr[min(MAXBREAK,v.ev_length)] = '\0';
			}
		}
	}
	
	
	if (parm->pCount >= (4 + iWhatFunction))  {
		if (parm->p[3 + iWhatFunction].val.ev_type != 'R') {  // This parameter was not passed by reference.
			if ( parm->p[3 + iWhatFunction].val.ev_type == 'I' || parm->p[3 + iWhatFunction].val.ev_type == 'N') {
				nStartOccurrenceDef = (parm->p[3 + iWhatFunction].val.ev_type == 'I') ? parm->p[3 + iWhatFunction].val.ev_long : (long) parm->p[3 + iWhatFunction].val.ev_real  ;
				if ( nStartOccurrenceDef < -1 || nStartOccurrenceDef == 0 )
					_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
			}
			else 
				_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
		}
		
		if (parm->pCount >= (5 + iWhatFunction))  {
			if (parm->p[4 + iWhatFunction].val.ev_type != 'R') {  // This parameter was not passed by reference.
				if ( parm->p[4 + iWhatFunction].val.ev_type == 'I' || parm->p[4 + iWhatFunction].val.ev_type == 'N') {
					nNumberOfOccurrencesDef = (parm->p[4 + iWhatFunction].val.ev_type == 'I') ? parm->p[4 + iWhatFunction].val.ev_long : (long) parm->p[4 + iWhatFunction].val.ev_real  ;
					if ( nNumberOfOccurrencesDef < -1 || nNumberOfOccurrencesDef == 0 )
						_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
				}
				else  
					_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
			}
			
			if (parm->pCount >= (6 + iWhatFunction))  {
				if (parm->p[5 + iWhatFunction].val.ev_type != 'R') {  // This parameter was not passed by reference.
					if ( parm->p[5 + iWhatFunction].val.ev_type == 'I' || parm->p[5 + iWhatFunction].val.ev_type == 'N') {
						nFlagsDef = (parm->p[5 + iWhatFunction].val.ev_type == 'I') ? parm->p[5 + iWhatFunction].val.ev_long : (long) parm->p[5 + iWhatFunction].val.ev_real  ;
						
						if (nFlagsDef < 0 || nFlagsDef > (iWhatFunction != FSTRFILTEREX ? 3:1) )
							_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
					}   
					else 
						_Error(901) ; // Function argument value, type, or count is invalid (Error 11)
				}		
			}
			
		}
		
	}			
	// ------- check the parameters ------- 
	
	
	// get the first parameter
	t = gethandle(parm, 0);
	if (t == 0) 
		_UserError("Data type mismatch\n");
	
	nLenString =  (long) _StrLen((char FAR *)_HandToPtr(t)) ;
	
	
	
	if (iWhatFunction == FSTRFILTEREX) {
		//    ,      
		// we will probably change the original string so we need to copy it in another place
		_HLock(t);
		if ( (t_tran = _AllocHand(nLenString+1)) == 0) {
			_Error(182);	// insufficient memory "There is not enough memory to complete this operation."
		}
		((char FAR *) _HandToPtr(t_tran))[nLenString] = '\0';
		_HLock(t_tran);
		_StrCpy((char FAR *)_HandToPtr(t_tran), (char FAR *)_HandToPtr(t)); 
		_HUnLock(t_tran);
		_HUnLock(t);
    }
	
	   
	   if (nRowsSearched == 0) {
		   nRowsSearched = min(MAXQNTDIFFWORDS, _ALen(parm->p[1].loc.l_NTI, AL_SUBSCRIPT1));
	   }
	   
	   
	   
	   //    
	   // nRowsSearched      ,   .
	   //        ,       .
	   //         ,      .
	   // ------- the main For cycle  ------- 
	   for (i = 1; i <= nRowsSearched; i++ ) {
		   _HUnLock(t);
		   if (parm->p[1].val.ev_type == 'R') {  // This parameter was passed by reference.
			   parm->p[1].loc.l_sub1 = (USHORT) i ; //  the element of array  
			   if (errcode = _Load(&parm->p[1].loc, &aVal))  { // We receive value of an element
				   _Error(-errcode) ; // exits api
			   }
		   }
		   else {
			   aVal = parm->p[1].val ; // we do not have to release a memory handle !
		   }
		   
		   if ( aVal.ev_type != 'C')
			   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
		   
		   //  ,    
		   NullTerminate(&aVal);    // Convert to ASCIIZ
		   
		   ArrayLengthOfFoundSubStr_or_Words[i-1] = aVal.ev_length ; //   
		   
		   //  nStartOccurrence  Specifies which occurrence of cExpressionSought to replace first. 
		   nStartOccurrence = nStartOccurrenceDef;
		   //  nNumberOfOccurrences  Specifies the number of occurrences of cExpressionSought to replace. 
		   nNumberOfOccurrences = nNumberOfOccurrencesDef;
		   //  nFlags  Specifies Case-sensitive search criteria To Apply To This Function.
		   //  Valid Values are 0 (the Default), 1, 2, 3
		   //  0, 2 Case-sensitive search
		   //  1, 3 Case insensitive search
		   nFlags = nFlagsDef;
		   
		   
		   if (parm->pCount >= (4 + iWhatFunction))  {
			   //  nStartOccurrence  Specifies which occurrence of cExpressionSought to replace first. 
			   if (parm->p[3 + iWhatFunction].val.ev_type == 'R') {  // This parameter was passed by reference.
				   if ( _ALen(parm->p[3 + iWhatFunction].loc.l_NTI, AL_SUBSCRIPT1) >= i) {
					   parm->p[3 + iWhatFunction].loc.l_sub1 = (USHORT) i ; //  the element of array  
					   if (errcode = _Load(&parm->p[3 + iWhatFunction].loc, &v)) { // We receive value of an element
						   _Error(-errcode) ; // exits api
					   }
					   if ( v.ev_type == 'I' || v.ev_type == 'N') {
						   nStartOccurrence = (v.ev_type == 'I') ? v.ev_long : (long) v.ev_real  ;
						   if ( nStartOccurrence < -1 || nStartOccurrence == 0 )
							   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
					   }
					   else {
						   if ( v.ev_type == 'C')
							   _FreeHand(v.ev_handle) ; 
						   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
					   } 
				   }
			   }
			   //  nNumberOfOccurrences  Specifies the number of occurrences of cExpressionSought to replace. 
			   if (parm->pCount >= (5 + iWhatFunction))  {
				   if (parm->p[4 + iWhatFunction].val.ev_type == 'R') {  // This parameter was passed by reference.
					   if ( _ALen(parm->p[4 + iWhatFunction].loc.l_NTI, AL_SUBSCRIPT1) >= i) {
						   parm->p[4+ iWhatFunction].loc.l_sub1 = (USHORT) i ; //  the element of array  
						   if (errcode = _Load(&parm->p[4 + iWhatFunction].loc, &v)) {// We receive value of an element
							   _Error(-errcode) ; // exits api
						   }  
						   if ( v.ev_type == 'I' || v.ev_type == 'N') {
							   nNumberOfOccurrences = (v.ev_type == 'I') ? v.ev_long : (long) v.ev_real  ;
							   if ( nNumberOfOccurrences < -1 || nNumberOfOccurrences == 0 )
								   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
						   } 
						   else {
							   if ( v.ev_type == 'C')
								   _FreeHand(v.ev_handle) ; 
							   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
						   } 
					   }
				   }
				   //  nFlags  Specifies Case-sensitive search criteria To Apply To This Function.
				   if (parm->pCount >= (6 + iWhatFunction))  {
					   if (parm->p[5 + iWhatFunction].val.ev_type == 'R') {  // This parameter was passed by reference.
						   if ( _ALen(parm->p[5 + iWhatFunction].loc.l_NTI, AL_SUBSCRIPT1) >= i) {
							   parm->p[5 + iWhatFunction].loc.l_sub1 = (USHORT) i ; //  the element of array  
							   if (errcode = _Load(&parm->p[5 + iWhatFunction].loc, &v)) { // We receive value of an element
								   _Error(-errcode) ; // exits api
							   }  
							   if ( v.ev_type == 'I' || v.ev_type == 'N') {
								   nFlags = (v.ev_type == 'I') ? v.ev_long : (long) v.ev_real  ;
								   if (nFlags < 0 || nFlags > 3)
									   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
							   }
							   else {
								   if ( v.ev_type == 'C')
									   _FreeHand(v.ev_handle) ; 
								   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
							   } 
						   }
					   }
				   }
				   
			   }
			   
		   }
		   
		   if (nStartOccurrence == -1)
			   nStartOccurrence = 1;
		   
		   // nStartOccurrence -          
		   // nNumberOfOccurrences -       
		   
		   //       ,   foundSubSrt_or_Words.
		   //  foundSubSrt_or_Words         TYPE_CASE_AND_NUMBER.
		   // TYPE_CASE_AND_NUMBER        .
		   //     icompare_funct,   position  foundSubSrt_or_Words.
		   //    .
		   
		   nHowmanyhavebeenfound = 0 ;
		   nHowmanyhavebeenfoundForReplace = 0 ;
		   
		   if (aVal.ev_length > 0) {
			   for (k = 0; k <= nLastRowForCycle; k++ ) {
				   
				   _HLock(t);
				   _HLock(aVal.ev_handle);   // Lock string passed value
				   
				   if (nLastRowForCycle == 0) {
					   pcSearched  =  (char FAR *)_HandToPtr(t); //        
				   }
				   else {  //    ""
					   if (k == 0 ) {
						   pcSearched  =  (char FAR *)_HandToPtr(t) ; 
					   }     
					   else {
						   pcSearched  =  (char FAR *)_HandToPtr(t) + ArrayFoundSubStr_or_Words[k-1].position + 
							   ArrayLengthOfFoundSubStr_or_Words[getbits(ArrayFoundSubStr_or_Words[k-1].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) - 1] ; 
					   }  
				   }
				   
				   nHowmanyhavebeenfoundForReplace += 
					   AuxiliarySearchFunction(&ArrayFoundSubStr_or_Words[nLastRowForCycle + nHowmanyhavebeenfoundForReplace], &nHowmanyhavebeenfound, (long)(pcSearched-(char FAR *)_HandToPtr(t)), i, pcSearched, &aVal, nStartOccurrence, nNumberOfOccurrences, nFlags +  (nFlags == 2 && parm->p[2].val.ev_type == 'C' ? 2:0), (iWhatFunction == FWORDTRANEX) ? bkstr: NULL) ;
				   
			   } 
		   }
		   
		   if (nLastRowForCycle + nHowmanyhavebeenfoundForReplace > MAXCNTWORDS) {
			   _UserError(ERRMSGMAXCNTWORDS);
		   }
		   
		   nLastRowForCycle += nHowmanyhavebeenfoundForReplace;
		   
		   if (nHowmanyhavebeenfoundForReplace > 0) {
			   ArrayLengthOfReplacedSubStr_or_Words[i-1] = SEARCHEDSUBSTRINGWASFOUND ;  //       
			   
			   if (iWhatFunction != FSTRFILTEREX) {
				   if (nFlags == 2 && parm->p[2].val.ev_type == 'R') {
					   //  nFlags = 2      ,
					   //       .
					   //                 . 
					   //    ,         nFlags  2.
					   whatiscase = fwhatiscase((char FAR *)_HandToPtr(aVal.ev_handle), aVal.ev_length) ;
					   // returns 'U' if the string has a UPPER case
					   // returns 'L' if the string has a lower case
					   // returns 'P' if the string has a Proper case
					   // else this function returns '\0' 
					   switch(whatiscase)	{
					   case 'U':
						   whatiscase = (char)1 ; 
						   break ;
					   case 'L':
						   whatiscase = (char)2 ;
						   break ;
					   case 'P':
						   whatiscase = (char)3 ;
						   break ;
					   default:
						   break ;
					   }
					   
					   if (whatiscase) 
						   ArrayLengthOfReplacedSubStr_or_Words[i-1] += whatiscase ;
				   }
				   
			   }
			   if ( nLastRowForCycle > 0 && i > 1) {
				   /* Sort remaining args using Quicksort algorithm: */
				   qsort( (void *)ArrayFoundSubStr_or_Words, (size_t)nLastRowForCycle, sizeof(foundSubSrt_or_Words), icompare_funct);
			   }
			   _HUnLock(t);
			   _HUnLock(aVal.ev_handle);
		   }
		   
		   
		   _HUnLock(aVal.ev_handle);   // Unlock string passed value
		   
		   if (parm->p[1].val.ev_type == 'R')   // This parameter was passed by reference.
			   _FreeHand(aVal.ev_handle) ;  // releases a memory handle previously allocated by _Load 
	   }
	   // ------- End of the main For cycle  ------- 	
	   //   
	   
	   if (iWhatFunction != FSTRFILTEREX) {
		   if (parm->pCount >= 3 )
			   if (parm->p[2].val.ev_type != 'C' && parm->p[2].val.ev_type != 'R') 
				   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
			   
			   
			   for (i = 1; i <= nRowsSearched; i++ ) {
				   if (ArrayLengthOfReplacedSubStr_or_Words[i-1]) { //       ,    
					   if (parm->pCount >= 3 ) {  // the 3-th parameter was passed
						   if (parm->p[2].val.ev_type == 'R') {  // This parameter was passed by reference.
							   if ( _ALen(parm->p[2].loc.l_NTI, AL_SUBSCRIPT1) >= i) {
								   parm->p[2].loc.l_sub1 = (USHORT) i ; //  the element of array  
								   if (errcode = _Load(&parm->p[2].loc, &aVal))  { // We receive value of an element
									   _Error(-errcode) ; // exits api
								   }
								   if ( aVal.ev_type != 'C')
									   _Error(901) ; // Function argument value, type, or count is invalid (Error 11)
								   
								   NullTerminate(&aVal);    // Convert to ASCIIZ
								   _HLock(aVal.ev_handle);   // Lock string passed value
								   
								   //        ,      ,
								   //        (  nFlags = 2)
								   switch(ArrayLengthOfReplacedSubStr_or_Words[i-1]-SEARCHEDSUBSTRINGWASFOUND)	{
								   case 1:  // 'U'
									   _strupr((char FAR *)_HandToPtr(aVal.ev_handle)) ; 
									   break ;
								   case 2:  // 'L'
									   _strlwr((char FAR *)_HandToPtr(aVal.ev_handle)) ; 
									   break ;
								   case 3:  // 'P'
									   ((char FAR *) _HandToPtr(aVal.ev_handle))[0] = toupper( *((char FAR *)_HandToPtr(aVal.ev_handle))) ;
									   _strlwr((char FAR *)_HandToPtr(aVal.ev_handle)+1) ; 
									   break ;
								   default:
									   break ;
								   }
								   
								   if (ArrayLengthOfReplacedSubStr_or_Words[i-1]-SEARCHEDSUBSTRINGWASFOUND) {
									   _Store(&parm->p[2].loc, &aVal);
								   }  
								   
								   ArrayLengthOfReplacedSubStr_or_Words[i-1] = aVal.ev_length ; //   
								   _HUnLock(aVal.ev_handle);   // Unlock string passed value
								   _FreeHand(aVal.ev_handle) ;  // releases a memory handle previously allocated by _Load 
							   }
							   else {
								   ArrayLengthOfReplacedSubStr_or_Words[i-1] = 0 ;
							   }
						   }
						   else {  //       ,     
							   ArrayLengthOfReplacedSubStr_or_Words[i-1] = parm->p[2].val.ev_length ; 
						   }
					   }
					   else {   // the third parameter was not passed
						   ArrayLengthOfReplacedSubStr_or_Words[i-1] = 0 ;
					   }
				   }
			   }  // end of For Cycle
	   }
	   
	   //     
	   // looks for a length of a returned string
	   for ( i = 0 ; i < nLastRowForCycle ; i++) {
		   if (iWhatFunction != FSTRFILTEREX) {
			   nLenReturnedString = nLenReturnedString - 
				   ArrayLengthOfFoundSubStr_or_Words[getbits(ArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) - 1] 
				   + ArrayLengthOfReplacedSubStr_or_Words[getbits(ArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) - 1] ; 
		   }
		   else {
			   nLenReturnedString = nLenReturnedString + 
				   ArrayLengthOfFoundSubStr_or_Words[getbits(ArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) - 1] ;
		   }
	   } 
	   
	   
	   
	   if (iWhatFunction != FSTRFILTEREX) {
           nLenReturnedString += nLenString;
		   if (nLastRowForCycle > 0) {
			   _HUnLock(t);
			   if ( (t_tran = _AllocHand(nLenReturnedString + 1)) == 0) {
				   _Error(182);	// insufficient memory "There is not enough memory to complete this operation."
			   }
			   _HLock(t_tran);
			   ((char FAR *) _HandToPtr(t_tran))[nLenReturnedString] = '\0';
			   _HUnLock(t_tran);
		   }
	   }
	   
	   
	   if (iWhatFunction != FSTRFILTEREX) {
		   // -------- make the returned string  for StrtranEx and WordtranEx  --------	   
		   for ( i = 0 ; i < nLastRowForCycle ; i++) {
			   _HLock(t_tran);		
			   _HLock(t);
			   if (i) {
				   nLenStrSought = ArrayLengthOfFoundSubStr_or_Words[getbits(ArrayFoundSubStr_or_Words[i-1].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) - 1] ;
				   _MemMove((void FAR *)((char FAR *)_HandToPtr(t_tran)+j),(void FAR *)((char FAR *) _HandToPtr(t)+ArrayFoundSubStr_or_Words[i-1].position+nLenStrSought), (unsigned int) (ArrayFoundSubStr_or_Words[i].position  - (ArrayFoundSubStr_or_Words[i-1].position+nLenStrSought)) ) ;			
				   j += (ArrayFoundSubStr_or_Words[i].position - (ArrayFoundSubStr_or_Words[i-1].position+nLenStrSought));
			   }
			   else {
				   j =  ArrayFoundSubStr_or_Words[i].position ;
				   _MemMove(_HandToPtr(t_tran),_HandToPtr(t), (unsigned int) (j)) ;
				   
			   }
			   _HUnLock(t_tran);		
			   _HUnLock(t);
			   
			   nLenStrReplacement = ArrayLengthOfReplacedSubStr_or_Words[getbits(ArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) - 1] ;
			   
			   
			   if (nLenStrReplacement > 0) {  		// copy cWordReplacement
				   if (parm->p[2].val.ev_type == 'R') {  // This parameter was passed by reference.
					   nNumberOfRowSubstrForReplace = (USHORT) getbits(ArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) ; //  the element of array  
					   //           ,
					   //         
					   //         _Load 
					   //      
					   if (  (parm->p[2].loc.l_sub1 != nNumberOfRowSubstrForReplace) || !NeedReleaseMem ) {
						   if (NeedReleaseMem)
							   _FreeHand(aVal.ev_handle) ;  // releases a memory handle previously allocated by _Load, if it needs 
						   NeedReleaseMem = (char)1; 
						   parm->p[2].loc.l_sub1 = nNumberOfRowSubstrForReplace ;
						   if (errcode = _Load(&parm->p[2].loc, &aVal)) { // We receive value of an element
							   _Error(-errcode) ; // exits api
						   } 
					   }
				   }
				   else {
					   aVal = parm->p[2].val ;
				   }
				   
				   
				   _HLock(t_tran);
				   _HLock(aVal.ev_handle);   // Lock string passed value
				   
				   _MemMove((void FAR *)((char FAR *)_HandToPtr(t_tran)+j), _HandToPtr(aVal.ev_handle), (unsigned int) nLenStrReplacement) ;
				   
				   
				   _HUnLock(aVal.ev_handle);   // Unlock string passed value
				   
				   
				   // nFlags == 3 and it needs to be converted  or 
				   // nFlags == 2 and parm->p[2].val.ev_type == 'C' and it needs to be converted 
				   if (getbits(ArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 1  , 2)) { 
					   ((char FAR *) _HandToPtr(t_tran))[j+nLenStrReplacement] = '\0';
					   switch(getbits(ArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 1  , 2))	{
					   case 1:  // 'U'
						   _strupr((char FAR *)_HandToPtr(t_tran)+j) ; 
						   break ;
					   case 2:  // 'L'
						   _strlwr((char FAR *)_HandToPtr(t_tran)+j) ; 
						   break ;
					   case 3:  // 'P'
						   ((char FAR *) _HandToPtr(t_tran))[j] = toupper( *((char FAR *)_HandToPtr(t_tran)+j)) ;
						   _strlwr((char FAR *)_HandToPtr(t_tran)+j+1) ; 
						   break ;
					   default:
						   break ;
					   }
				   } 
				   
				   _HUnLock(t_tran);
			   }
			   j += nLenStrReplacement ;
		   }
		   
		   if (NeedReleaseMem)
			   _FreeHand(aVal.ev_handle) ;  // releases a memory handle previously allocated by _Load, if it needs 
		   
		   // -------- copy the rest of the string cSearched --------
		   if (nLastRowForCycle > 0) {
			   nLenStrSought = ArrayLengthOfFoundSubStr_or_Words[getbits(ArrayFoundSubStr_or_Words[nLastRowForCycle-1].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) - 1] ;
			   _HLock(t);	
			   _HLock(t_tran);		   
			   _MemMove((void FAR *)((char FAR *)_HandToPtr(t_tran)+j),(void FAR *)((char FAR *) _HandToPtr(t)+ArrayFoundSubStr_or_Words[nLastRowForCycle-1].position+nLenStrSought), (unsigned int) (nLenString  - (ArrayFoundSubStr_or_Words[nLastRowForCycle-1].position+nLenStrSought - 1)) ) ;			
			   _HUnLock(t);	
			   _HUnLock(t_tran);
		   }    
		   // -------- make the returned string for StrtranEx and WordtranEx --------	   
	   }
	   else {
		   // -------- make the returned string  for StrfilterEx  --------	 
		   if (nLenString != nLenReturnedString) { // it is not a same string as the original string
			   _HLock(t_tran);		
			   j = 0;
			   for ( i = 0 ; i < nLastRowForCycle ; i++) {
				   nLenStrSought = ArrayLengthOfFoundSubStr_or_Words[getbits(ArrayFoundSubStr_or_Words[i].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) - 1] ;
				   _MemMove( (void FAR *)((char FAR *)_HandToPtr(t_tran)+j), (void FAR *)((char FAR *) _HandToPtr(t_tran)+ArrayFoundSubStr_or_Words[i].position), (unsigned int) nLenStrSought) ;			
				   j += nLenStrSought;
			   }
			   ((char FAR *) _HandToPtr(t_tran))[nLenReturnedString] = '\0';
			   _HUnLock(t_tran);
			   if (!_SetHandSize(t_tran, nLenReturnedString+1)) {
				   _Error(182); // "Insufficient memory" "There is not enough memory to complete this operation."
			   }
		   }
		   // -------- make the returned string  for StrfilterEx  --------	 
	   }
	   
	   
	   
	   // -------- report of the work of the function -------- 
	   // if the 6-th (StrfilterEx), 7-th (StrtranEx) or 8-th (WordtranEx)  parameter has been passed
	   if (nLastRowForCycle && (parm->pCount >= (7 + iWhatFunction))) {	   
		   Value v1;
		   char FAR *varName;
		   Locator loc;
		   NTI nti;
		   
		   NullTerminate(&parm->p[6 + iWhatFunction].val);     // Convert to ASCIIZ
		   _HLock(parm->p[6 + iWhatFunction].val.ev_handle);
		   varName = (char FAR *) _HandToPtr(parm->p[6 + iWhatFunction].val.ev_handle);
		   
		   // delete the array or a variable if they earlier existed
		   if ((nti = _NameTableIndex(varName)) > -1) 
			   if (_FindVar(nti, -1, &loc)) 
				   if ((errcode =_Release(nti)) < 0)
					   _Error(-errcode);
				   
				   if (nLastRowForCycle) {
					   loc.l_subs = 2;
					   loc.l_sub1 = (USHORT)nLastRowForCycle;
					   loc.l_sub2 = (iWhatFunction == FSTRFILTEREX ? 2 :3);
					   // we create an array 
					   // this function in version for 8.0 below, can place in the array 16250 words because the array has 4 columns and must have fewer than 65,000 elements.
					   // in LCK versions 9.0 this function can place in the array  65000 words a maximum.
					   // If is when the quantity of words exceeds the admissible quantity there will be an error message " Too many variables "
					   
					   if ((nti = _NewVar(varName, &loc, NV_PUBLIC)) < 0)  // or NV_PRIVATE
						   _Error(-nti);  		// _NewVar() returns negative Visual FoxPro error number
					   
					   if (_FindVar(nti, -1, &loc)) {
						   for ( loc.l_sub1 = 1; loc.l_sub1 <= _ALen(nti, AL_SUBSCRIPT1); loc.l_sub1++) {
							   for ( loc.l_sub2 = 1; loc.l_sub2 <= _ALen(nti, AL_SUBSCRIPT2); loc.l_sub2++) {
								   v1.ev_type = 'I';
								   switch (loc.l_sub2) {
								   case 1 :
									   v1.ev_long = ArrayFoundSubStr_or_Words[loc.l_sub1 - 1].position + 1 ;
									   break;
								   case 2 :
									   v1.ev_long = (USHORT) getbits(ArrayFoundSubStr_or_Words[loc.l_sub1 - 1].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 3 , sizeof(TYPE_CASE_AND_NUMBER)*8-2) ;
									   break;
								   case 3 :
									   v1.ev_long = (USHORT) getbits(ArrayFoundSubStr_or_Words[loc.l_sub1 - 1].case_and_number, sizeof(TYPE_CASE_AND_NUMBER)*8 - 1  , 2) ;
									   break;
								   default:
									   break;
								   }
								   _Store(&loc, &v1);
							   }
						   } 
					   }
				   }
				   _HUnLock(parm->p[6 + iWhatFunction].val.ev_handle);
	   } 
	   // -------- report of the work of the function -------- 
	   
	   
	   
	   if (nLastRowForCycle > 0  || iWhatFunction ==  FSTRFILTEREX) {
		   _HLock(t_tran);
		   _RetChar((char FAR *)_HandToPtr(t_tran)) ;
		   _HUnLock(t_tran);	
		   _FreeHand(t_tran);
	   }
	   else {
		   _HLock(t);
		   _RetChar((char FAR *)_HandToPtr(t)) ;
		   _HUnLock(t);
	   }
	   
	   if (parm->p[0].val.ev_type != 'C')  // we must not free handles passed to them in their ParamBlk !
		   _FreeHand(t);	 /* Free MHANDLEs we allocate, but not handles passed in ParamBlk. */
}


/*
STRTRANEX() ,  ,         ,      FoxPro STRTRAN().
STRTRANEX()   ,    ,            ,          .
STRTRANEX (cSearched, cArExpressionSought | cExpressionSough, [cArReplacement | cReplacement][, nArStartOccurrence | nStartOccurrence] [, nArNumberOfOccurrences | nNumberOfOccurrences] [, nArFlags | nFlags],  [ArReport])
   
WORDTRANEX() ,  ,        ,     WORDTRAN().
WORDTRANEX()    ,    ,            ,         .
WORDTRANEX (cSearched, cArExpressionSought | cExpressionSough, [cArReplacement | cReplacement] [, cDelimiters] [, nArStartOccurrence | nStartOccurrence] [, nArNumberOfOccurrences | nNumberOfOccurrences] [, nArFlags | nFlags],  [ArReport])
   
 STRTRANEX()   WORDTRANEX()   ,   WORDTRANEX()   ,   ,  ,  WORDTRANEX()     ,    .

cSearched  ,    STRTRANEX()   WORDTRANEX()     .
cArExpressionSought     cExpressionSought ,       ,    cSearched.
     ,   cExpressionSought,       ,    STRTRAN().
cArReplacement      cReplacement ,              cArExpressionSought    cSearched.
    ,     cArExpressionSought       . 
     cArReplacement       cArExpressionSought ,     cArReplacement  .
     cArReplacement       cArExpressionSought,      cArExpressionSought    .
     ,   cReplacement,      cArExpressionSought       cReplacement.
cDelimiters (   WORDTRANEX)  ,   256  -   ,   ,         cSearched.
    ,  ,     . 
WORDTRANEX()      cDelimiters   ,     cDelimiters   .
nArStartOccurrence    nStartOccurrence ,    ,       cArExpressionSought  cSearched   .
     nArStartOccurrence      cArExpressionSought ,     nArStartOccurrence .
     nArStartOccurrence      cArExpressionSought,      cArExpressionSought  ,      .
,   nStartOccurrence  4,          cArExpressionSought    cSearched,          .
 ,      nArStartOccurrence  4,          cArExpressionSought    cSearched,         cArExpressionSought     .
        ,     nStartOccurrence   ,   -1. 
  (   WORDTRANEX())    ,   nStartOccurrence,       cArExpressionSought     ,     nStartOccurrence.
nArNumberOfOccurrences    nNumberOfOccurrences ,          cArExpressionSought     cSearched,   .     ,        cArExpressionSought    cSearched,     ,  . 
     nArNumberOfOccurrences      cArExpressionSought ,     nArNumberOfOccurrences .
     nArNumberOfOccurrences      cArExpressionSought,      cArExpressionSought   ,      .
 ,   (   WORDTRANEX())    ,   nNumberOfOccurrences.   ,      cArExpressionSought    nNumberOfOccurrences  ,     .

nArFlags     nFlags           :
-
nFlags,      nArFlags  
0 ( )    ,       .
1     ,       .
2    ,                 .         ,      ,      (       ,   ).
 3     ,                 .         ,      ,      (       ,   ).
-
     nArFlags      cArExpressionSought ,     nArFlags .
     nArFlags      cArExpressionSought,      cArExpressionSought       0  .
  (   WORDTRANEX())    ,   nFlags,      cArExpressionSought          nFlags.

ArReport           ,   
 ,        cSearched,       
 ,          cArExpressionSought    
 ,           
0     ,           
1       
2       
3       ,      ,   . 
 ,  ArReport      STRTRANEX()   WORDTRANEX()  .
     ArReport       .
    ,  ArReport   .

:
     nStartOccurrence -      nNumberOfOccurrences  .   cReplacement , cExpressionSought      ().     nStartOccurrence,
            .  nNumberOfOccurrences    .
 -1    , , ,      nFlags,      .

STRTRANEX (cSearched,  cExpressionSough, cReplacement, nStartOccurrence, nNumberOfOccurrences, nFlags)       
STRTRAN (cSearched, cExpressionSough, cReplacement, nStartOccurrence, nNumberOfOccurrences, nFlags)

  ,  ,     A   B ,   ,   B   A,        .
  ()     .

*/
void FAR strtranex(ParamBlk FAR *parm)   {ftranex(parm, FSTRTRANEX) ;}  
void FAR wordtranex(ParamBlk FAR *parm)  {ftranex(parm, FWORDTRANEX);}  

/*
STRFILTEREX()         memo ,   ,      
         STRFILTER().
STRFILTEREX (cSearched, cArExpressionSought | cExpressionSough [, nArStartOccurrence | nStartOccurrence] [, nArNumberOfOccurrences | nNumberOfOccurrences] [, nArFlags | nFlags],  [ArReport])
   


cSearched  ,    STRFILTEREX()    ,   .
cArExpressionSought     cExpressionSought ,        , ,   cSearched.
     ,   cExpressionSought,        ,   STRFILTER(),   ,      ,  cExpressionSought ,
      cExpressionSought     STRFILTER().
nArStartOccurrence    nStartOccurrence ,    ,       cArExpressionSought  cSearched     .
     nArStartOccurrence      cArExpressionSought ,     nArStartOccurrence .
     nArStartOccurrence      cArExpressionSought,      cArExpressionSought  ,      .
,   nStartOccurrence  4,          cArExpressionSought    cSearched,        .
 ,      nArStartOccurrence  4,          cArExpressionSought    cSearched,         cArExpressionSought   .
        ,     nStartOccurrence   ,   -1. 
     ,   nStartOccurrence,       cArExpressionSought     ,     nStartOccurrence.
nArNumberOfOccurrences    nNumberOfOccurrences ,          cArExpressionSought     cSearched,   .     ,        cArExpressionSought    cSearched,     ,  . 
     nArNumberOfOccurrences      cArExpressionSought ,     nArNumberOfOccurrences .
     nArNumberOfOccurrences      cArExpressionSought,      cArExpressionSought   ,      .
 ,      ,   nNumberOfOccurrences.   ,      cArExpressionSought    nNumberOfOccurrences  ,     .

nArFlags     nFlags            :
-
nFlags,      nArFlags  
0 ( )    
1     
 -
     nArFlags      cArExpressionSought ,     nArFlags .
     nArFlags      cArExpressionSought,      cArExpressionSought       0  .
      ,   nFlags,      cArExpressionSought          nFlags.

ArReport           ,   
 ,        cSearched,       
 ,          cArExpressionSought    
 ,  ArReport      STRFILTEREX()   .
     ArReport       .
    ,  ArReport   .
:
     nStartOccurrence -      nNumberOfOccurrences  .      nStartOccurrence,
         .  nNumberOfOccurrences    .
 -1    , , ,      nFlags,      .
*/ 
void FAR strfilterex(ParamBlk FAR *parm) {ftranex(parm, FSTRFILTEREX);}  		  

//--------------- End  strtranex, wordtranex, strfilterex  ----------------------------

//--------------- Begin Converting to/from Roman numerals  ----------------------------
#define ERRMESSAGE	"Out of range, must be between 1 and 3999"
#define ROMANNUMERALS "IVXLCDM"   // I V X  L  C   D   M
#define WRONGROMANNUMBER -1L      // 1 5 10 50 100 500 1000

void FAR arabtoroman(ParamBlk FAR *parm)  {
	char lnNum, i, j, l = 0 ;
	int k ;
	char buffer[5] ;
	char temp[sizeof(ERRMESSAGE)] =  ERRMESSAGE;
	char romannumerals[sizeof(ROMANNUMERALS)] = ROMANNUMERALS ;
	
	switch(parm->p[0].val.ev_type)  {
	case 'N':
		k = (int)parm->p[0].val.ev_real ;
		break ;                 
	case 'I':
		k = (int)parm->p[0].val.ev_long ;
		break ;
	case 'C':
		NullTerminate(&parm->p[0].val);     // Convert to ASCIIZ
		_HLock(parm->p[0].val.ev_handle);   // Lock string passed value
		k = (int)atoi((const char *)_HandToPtr(parm->p[0].val.ev_handle));
		_HUnLock(parm->p[0].val.ev_handle);   // Lock string passed value                    Value  TmpVal ;
		break ;
	default:
		_Error(302);	// Data type mismatch
		break ;
	}
	
	if (k >= 1 && k <= 3999) {
		itoa(k, buffer, 10); 
		for( i = (char)_StrLen(buffer); i >= 1; i--) {
			lnNum = buffer[(char)_StrLen(buffer)-i]-'0';
			if (lnNum < 4)
				for( j = 0; j < lnNum; j++) 
					temp[l++] = romannumerals[(i-1)*2] ;           
				else {        
					if (lnNum == 4 || lnNum == 9) {
						temp[l++] = romannumerals[(i-1)*2] ;                    
						temp[l++] = romannumerals[i*2 - (lnNum == 4 ? 1 : 0)] ;                    
					}
					else {        
						temp[l++] = romannumerals[i*2 - 1] ;                    
						for( j = 0; j < (lnNum - 5); j++) 
							temp[l++] = romannumerals[(i-1)*2] ;           
					}        
				}
		}
		temp[l] = '\0' ;
	}
	_RetChar(temp);     
	return;
}

void FAR  romantoarab(ParamBlk FAR *parm)  { // Returns the number equivalent of a specified character Roman numeral expression
	int k, j=0, i, nResult = 0 ;
	unsigned long  nMult ;
	char lcRomanNumber[16] ;
	char romannumerals[sizeof(ROMANNUMERALS)] = ROMANNUMERALS ;
	
	_MemFill((void FAR *)lcRomanNumber,0, sizeof(lcRomanNumber)) ;
	NullTerminate(&parm->p[0].val);     // Convert to ASCIIZ
	_HLock(parm->p[0].val.ev_handle);   // Lock string passed value
	_strupr((char FAR *)_HandToPtr(parm->p[0].val.ev_handle));
	for(i = 0; i < _StrLen(_HandToPtr(parm->p[0].val.ev_handle)); i++ ) {
		if ((strchr((const char FAR *)romannumerals, (int)((char FAR *)_HandToPtr(parm->p[0].val.ev_handle))[i]) != NULL) 
			&& (j < (sizeof(lcRomanNumber)-1)) )
			lcRomanNumber[j++] =  ((char FAR *)_HandToPtr(parm->p[0].val.ev_handle))[i] ;
		else {  
			if (!isspace((int)((char FAR *)_HandToPtr(parm->p[0].val.ev_handle))[i] )) {
				_RetInt(WRONGROMANNUMBER, 4) ;
				return ;
			}   
		}
	}
	_HUnLock(parm->p[0].val.ev_handle);   // unlock string passed value
	
	k = _StrLen(lcRomanNumber) ;
	for(i = 1; i <= 4; i++ ) {
		if (k <= 0)
			break ;
		nMult = (unsigned long) pow(10, i-1) ;
		if (k > 1 && i< 4 && (lcRomanNumber[k - 2] == romannumerals[(i-1)*2]) && (lcRomanNumber[k - 1] == romannumerals[i*2-1])) { // CD or XL or IV
			nResult += 4*nMult ;
			k -= 2 ;
		} 
		else {
			if (k > 1 && i< 4 && (lcRomanNumber[k - 2] == romannumerals[(i-1)*2]) && (lcRomanNumber[k - 1] == romannumerals[i*2]) ) { //  CM or XC or IX
				nResult += 9*nMult ;
				k -= 2 ;
			} 
			else {
				for(j = 1; j <= 3 ; j++ )  { // MMM or CCC or XXX or III
					if (k <= 0)
						break ;
					if (lcRomanNumber[k-1] == romannumerals[(i-1)*2]) {
						nResult += nMult ; 
						k-- ;
					}
				}
				if (k <= 0)
					break ;
				if (lcRomanNumber[k-1] == romannumerals[i*2 - 1]) { // D or L or V
					nResult += 5*nMult ;
					k-- ;
				}
			}
		}
	}
	_RetInt((k == 0) ? nResult : WRONGROMANNUMBER, 4) ;     
	return;
}

//--------------- End Converting to/from Roman numerals  ----------------------------

void FAR  versionSt_Denis(ParamBlk FAR *parm) {
    _Dialog(6, VERSIONST_DENIS,	(char FAR *)0, "Ok", (char FAR *)0, 1, 1) ;
	// _RetChar(VERSIONST_DENIS);
}

#if  VERSION == VFP 
void FAR  onload(ParamBlk FAR *parm) {
/*
Value  TmpVal ;
_Evaluate(&TmpVal, "VERS(5)");
if  (TmpVal.ev_long < 900) 
; // version for 8.0 and below
	*/
	setlocale(LC_ALL, LOCLANGUAGE); //        
}

/*
char *setlocale(
int category,
const char *locale 
);
 setlocale      ,   category,  ,
   locale.  locale    
 (,       ),    ,
  ,   ,     /
  ,     ,    ,   strtime.
            ascanquick
      ,       
    ,   setlocale     _strlwr , ,   
*/
void FAR  SetLocale(ParamBlk FAR *parm) {
	UpperToLower(&parm->p[0].val) ;
	_HLock(parm->p[0].val.ev_handle);
	if ( setlocale(LC_ALL, _HandToPtr(parm->p[0].val.ev_handle)) != NULL )
		_RetChar(setlocale(LC_ALL, _HandToPtr(parm->p[0].val.ev_handle)));
	else
		_RetChar("The parameter is invalid, , for example: 'eng', 'fra'");
	
	_HUnLock(parm->p[0].val.ev_handle);
}
#endif

#if  VERSION == DOS
#define  BUFFERSIZE 68

void FAR makedir(ParamBlk FAR *parm) {
	char FAR *DIRname ;
	char FAR buffer[BUFFERSIZE];
	char FAR *pbuffer ;  
	int rezultat ;
	union  REGS iReg,oReg;
	struct SREGS sregs;
	
	_SetHandSize(parm->p[0].val.ev_handle,parm->p[0].val.ev_length+1);
	_HLock (parm->p[0].val.ev_handle);
	DIRname = _HandToPtr(parm->p[0].val.ev_handle);
	DIRname [parm->p[0].val.ev_length] ='\0';
	_fstrupr(DIRname);
	
	
	/*  21h  19h   
	 :     AX = 19h
	 :   AL    0 - A   1 - B    .. */
	iReg.h.ah = 0x19         ;
	int86(0x21,&iReg,&oReg)  ;
	buffer[0]= oReg.h.al+65  ;
	
	DEBUGMSG(MAIN,"  ...") 
		
		buffer[1]=':'      ;
	buffer[2]='\\'     ;
	pbuffer=&buffer[3] ;
	
	/*    ,          ,
	     1,      , 
	  ,      0 ,
	     -1,       */
	
	/*  21h  47h    
	 : AX = 47h , DL =   
	  0 -   1 - A   2 - B    ..
	  DS   64-   (  )
	  SI   64-   (  ) 
	   - 
	   :     CF  AX .  
	 -    ASCIIZ  CF   */
	iReg.h.ah = 0x47                   ;
	iReg.h.dl = 0                      ;
	sregs.ds  = FP_SEG(pbuffer)        ;
	iReg.x.si = FP_OFF(pbuffer)        ;
	int86x(0x21,&iReg,&oReg,&sregs)    ;
	
	SHOWMSG(MAIN,buffer)
		DEBUGMSG(MAIN,"  ...") 
		
		if ( chdir( DIRname ) == 0 ) {
			rezultat = 1 ;
		} 
		else {
			rezultat = mkdir( DIRname ) ;
			if (rezultat < 0)
				rezultat = -1 ; 
		}
		
		if (rezultat == 0) {
			DEBUGMSG(MAIN,"  ...") 
		}
		if (chdir( buffer ) == 0 ) {
			SHOWMSG(MAIN,buffer)
				DEBUGMSG(MAIN,"     ...") 
		}
		
		_HUnLock(parm->p[0].val.ev_handle);
		
		_RetInt(rezultat,10) ;
}  

void FAR bittest(ParamBlk FAR *parm) {
	_RetLogical(parm->p[0].val.ev_long&(int)pow(2,parm->p[1].val.ev_long)) ;
}

#endif

//          
void FAR NPrecision(ParamBlk FAR *parm) {
	_RetInt(parm->p[0].val.ev_length, 10);
}
//--------------------------------------------------------------------------

#if  VERSION == VFP 
#define STRPREPARATION  "STRPREPARATION"
#define GETALLWORDS "GETALLWORDS"
#define GETALLWORDS2 "GETALLWORDS2"
#define ARABTOROMAN "ARABTOROMAN"
#define ROMANTOARAB "ROMANTOARAB"
#define GETOCCURSWORD "GETOCCURSWORD"
#define STRFILTEREX "STRFILTEREX"
#else
#define STRPREPARATION  "STRPREPARA"
#define GETALLWORDS  "GETALLWORD"
#define GETALLWORDS2 "GETALLWOR2"
#define ARABTOROMAN "ARABTOROMA"
#define ROMANTOARAB "ROMANTOARA"
#define GETOCCURSWORD "GETOCCURSW"
#define STRFILTEREX "STRFILTERX"
#endif

FoxInfo myFoxInfo[] = {
	
#if !VFP9ANDABOVE
	{"ICASE",(FPFI)  icase, 25, "L,?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?,.?"},
#endif
	{"IFOR" , (FPFI) ifor, 5, "C,I,C,.I,.C"},
	{"IWHILE" , (FPFI) iwhile, 3, "C,C,.C"},  
	// " CASE  ,        
	{"IEXECCASE",(FPFI)  iexeccase, 23, "L,C,.C,.?,.C,.C,.?,.C,.C,.?,.C,.C,.?,.C,.C,.?,.C,.C,.?,.C,.C,.C,.C"},
	// "" IF  ,        
	{"IEXECIF",(FPFI)  iexecif, 5, "L,C,C,.C,.C"}, 
	{"EXECUTE", (FPFI) execute, 2, "C,.C"},
	{"FIELDNUM",(FPFI)  fieldnum, 2, "C,.?"},
	{"DANSLISTE",(FPFI)  dansliste, 2, "I,C"},
	{"CHECKLISTE",(FPFI)  checkliste, 1 , "C"},
	{"EXAMLISTE",(FPFI)  whendansliste, 0, "?"},
	{"INCREMENT",(FPFI)  increment, 2, "R,.I"},
	{"STRFILTER",(FPFI) strfilter, 2,"?,C"},         // filter out anything that isn't in second string
	{STRPREPARATION,(FPFI) strpreparation, 1,"C"},   //    [1-9]   [123456789]
	{"REVERSE", (FPFI) reverse, 1, "C"},             // function which accepts a string parameter and returns that string reversed
	// Working with arrays
	{"ARRAYSUM", (FPFI) arraysum, 4, "R,.I,.I,.I"},   
	{"ARRAYAVG", (FPFI) arrayavg, 4, "R,.I,.I,.I"},   
	{"ARRAYMAX", (FPFI) arraymax, 5, "R,.I,.I,.I,.R"},  
	{"ARRAYMIN", (FPFI) arraymin, 5, "R,.I,.I,.I,.R"},   
	{"ARRAYCNT", (FPFI) arraycnt, 4, "R,.I,.I,.I"},   
	{"VITESCAN", (FPFI) vitescan, 5, "R,?,.I,.I,.I"},
	{"ASCANQUICK", (FPFI) ascanquick, 6, "R,?,.I,.I,.I,.I"},
	{GETALLWORDS,  (FPFI) getallwords1, 3, "C,?,.C"},        // Inserts the words from a string into the array. 
	{GETALLWORDS2, (FPFI) getallwords2, 3, "C,?,.C"},        // Inserts the words from a string into the array.
	{"GETNUMWORD", (FPFI) getnumword, 5, "?,C,.?,.I,.I"},    // Returns the number of the word in a character string.
	{"GETATWORD",  (FPFI) getatword, 5, "?,C,.?,.I,.I"},     // Searches a string for the occurrence of word. 
	{"GETRATWORD", (FPFI) getratword, 5, "?,C,.?,.I,.I"},    // Returns the numeric position of the last (rightmost) occurrence of a word within string.
	{GETOCCURSWORD, (FPFI) getoccursword, 4, "?,C,.?,.I"},   // Returns the number of the word in a character string.
	{"WORDTRAN", (FPFI) wordtran, 7, "?,C,.C,.?,.I,.I,.I"},  // Searches a character expression or memo field for a word and replaces each occurrence with a second word.
	{"STRTRANEX", (FPFI) strtranex, 7, "?,?,.?,.?,.?,.?,.C"},   // Searches a character expression or memo field for a second character expression(s) and replaces each occurrence with a third character expression(s)
	{"WORDTRANEX", (FPFI) wordtranex, 8, "?,?,.?,.C,.?,.?,.?,.C"},  // Searches a character expression or memo field for a word(s) and replaces each occurrence with a second word(s).
	{STRFILTEREX, (FPFI) strfilterex, 6, "?,?,.?,.?,.?,.C"},    // A function with enhanced remove capabilities as compared to the function STRFILTER().
	// Converting to/from Roman numerals
	{ARABTOROMAN, (FPFI) arabtoroman, 1, "?"},
	{ROMANTOARAB, (FPFI) romantoarab, 1, "C"},  
	// Working with windows
	{"SAYINWIND",(FPFI)  SayInWindow,  4, "I,I,C,.C"},
	{"SETWINTITL",(FPFI)  SetWindowsTitle,  3, "C,.L,.C"},
	{"VST_DENIS",(FPFI)  versionSt_Denis, 0, "?"},
	{"NPRECISION",(FPFI)  NPrecision, 1, "N"}
#if VERSION == VFP 
	,{"ONLOAD", (FPFI) onload, CALLONLOAD, ""},
	{"SETLOCALE", (FPFI) SetLocale, 1, "C"}
#endif
#if VERSION == DOS
	,{"MAKEDIR",(FPFI)  makedir, 1,"C"},
	{"BITTEST",(FPFI)  bittest, 2,"I,I"} 
#endif
};

FoxTable _FoxTable = {
	(FoxTable FAR *)0, sizeof(myFoxInfo) / sizeof(FoxInfo), myFoxInfo
};
